#ifndef ATTRIBUTEPREDEFINEDTYPES_H
#define ATTRIBUTEPREDEFINEDTYPES_H

/// @file 
/// @author Jakub.Moscicki@cern.ch (kuba)

# include "AttributeTypes.h"
# include "POOLCore/Token.h"
#include "SealBase/IntBits.h"

namespace pool {
  /// Concrete specialization for a basic type. Other supported types needs to have their specializations.
  template<>
  class AttributeStaticTypeInfo<bool>
  {
  public:
    static typename_string_t type_name();
  };


  template<>
  class AttributeStaticTypeInfo<char>
  {
  public:
    static typename_string_t type_name();
  };

  template<>
  class AttributeStaticTypeInfo<unsigned char>
  {
  public:
    static typename_string_t type_name();
  };


  template<>
  class AttributeStaticTypeInfo<short>
  {
  public:
    static typename_string_t type_name();
  };

  template<>
  class AttributeStaticTypeInfo<unsigned short>
  {
  public:
    static typename_string_t type_name();
  };


  template<>
  class AttributeStaticTypeInfo<int>
  {
  public:
    static typename_string_t type_name();
  };

  template<>
  class AttributeStaticTypeInfo<unsigned int>
  {
  public:
    static typename_string_t type_name();
  };

#ifndef __x86_64__
 template<> 
 class AttributeStaticTypeInfo<long>
  {
  public:
    static typename_string_t type_name();
  };

  template<>
  class AttributeStaticTypeInfo<unsigned long>
  {
  public:
    static typename_string_t type_name();
  };
#endif

  template<>
  class AttributeStaticTypeInfo<float>
  {
  public:
    static typename_string_t type_name();
  };


  template<>
  class AttributeStaticTypeInfo<double>
  {
  public:
    static typename_string_t type_name();
  };


  template<>
  class AttributeStaticTypeInfo<long double>
  {
  public:
    static typename_string_t type_name();
  };


  template<>
  class AttributeStaticTypeInfo<std::string>
  {
  public:
    static typename_string_t type_name();
  };
  

  template<>
  class AttributeStaticTypeInfo<seal::IntBits<64>::SLeast>
  {
  public:
    static typename_string_t type_name();
  };


  template<>
  class AttributeStaticTypeInfo<seal::IntBits<64>::ULeast>
  {
  public:
    static typename_string_t type_name();
  };

  
  template<>
  class AttributeStaticTypeInfo<pool::Token>
  {
  public:
    static typename_string_t type_name();
  };
}

# endif
