#include "AttributeList/AttributeTypes.h"
#include "AttributeList/AttributeImplFactory.h"

/* Windows port:
   the factory map must also be made static in the function scope.
   apperently it is not enough if it is a data member of a theFactorySingleton
   (which is static in the function scope).

   explanation:

   Date: Thu, 6 Nov 2003 10:18:46 +0100
   From: Markus Frank <Markus.Frank@cern.ch>
   To: Jakub Moscicki <Jakub.Moscicki@cern.ch>
   Subject: RE: Attributelist & windows

   This I had as well in the beginning. This does not work.
   Typically maps have internal static storage for the
   end-nodes. If other static storage (theFactorySingleton)
   relies on this, things fall over.
*/

static std::map<std::string, pool::BaseAttributeFactory*>& baseFactories()
{
  static std::map<std::string, pool::BaseAttributeFactory*> fact;
  return fact;
}

pool::AttributeImplFactory::AttributeImplFactory()
{
}

pool::AttributeImplFactory& pool::AttributeImplFactory::theFactory()
{
  static pool::AttributeImplFactory theFactorySingleton;
  return theFactorySingleton;
}

void pool::AttributeImplFactory::_addref(pool::BaseAttributeFactory&f, pool::typename_string_t type_name)
{
  // FIXME: not found
  baseFactories()[type_name] = &f;
}

pool::AttributeBaseValue* pool::AttributeImplFactory::createAttributeImpl(pool::typename_string_t type_name)
{
  // FIXME: not found
  
  pool::BaseAttributeFactory *p = baseFactories()[type_name];

  if(p)
    return p->createAttributeImpl();
  else
    return 0;
}


const std::type_info*
pool::AttributeImplFactory::typeOfAttributeObject(typename_string_t type_name) const
{
 // FIXME: not found
  
  pool::BaseAttributeFactory *p = baseFactories()[type_name];

  if(p)
    return p->type();
  else
    return 0;
}

std::string
pool::AttributeImplFactory::typeNameOfAttributeObject( const std::type_info& type ) const
{
  const std::map<std::string, pool::BaseAttributeFactory*>& theBaseFactories = baseFactories();
  for ( std::map<std::string, pool::BaseAttributeFactory*>::const_iterator iSupportedTypes = theBaseFactories.begin();
        iSupportedTypes != theBaseFactories.end(); ++iSupportedTypes ) {
    if ( *( iSupportedTypes->second->type() ) == type ) return iSupportedTypes->first;
  }
  // FIXME: not found
  return "";
}


size_t pool::AttributeImplFactory::sizeOfAttributeObject(pool::typename_string_t type_name)
{
  // FIXME: not found
  
  pool::BaseAttributeFactory *p = baseFactories()[type_name];

  if(p)
    return p->sizeOfAttributeObject();
  else
    return 0;
}


