#ifndef POOL_ANYTYPE_H
#define POOL_ANYTYPE_H

#include <typeinfo>
#include <string>
#include "Reflex/Type.h"

namespace pool{

  class Guid;

  class AnyType {

  public: 
    
    AnyType();

    AnyType(const std::type_info& type);

    AnyType(const ROOT::Reflex::Type& c);
                     
    AnyType(const AnyType& aType);

    virtual ~AnyType();

    AnyType& operator=(const AnyType& aType);

    AnyType& operator=(const std::type_info& type);

    AnyType& operator=(const ROOT::Reflex::Type& aClass);

    operator bool() const;

    const std::type_info* getType() const; 

    std::string name() const;

    const ROOT::Reflex::Type& getClass() const; 

    void* cast(const AnyType& asType, const void* aPtr) const;

    bool hasBase(const AnyType& aBaseType) const;

    bool isBaseFor(const AnyType& forType) const;

    void destroy(void* aPtr);

    void reset();

  private:

    ROOT::Reflex::Type m_class;

    std::string m_className;

  };

}

#endif
