#ifndef POOL_CACHESVCEXCEPTION_H
#define POOL_CACHESVCEXCEPTION_H 

#include "POOLCore/Exception.h"
  
namespace pool    {

  /** @class CacheSvcException CacheSvcException.h pool/CacheSvcException.h

      Define generic Exception for CacheSvc misbehavior

      @author Giacomo Govi 
  */
  class CacheSvcException : public pool::Exception {
    
    public:
    /** Standard Constructor
        @param m : Message error message
    */
    explicit CacheSvcException(const std::string& m) 
    : pool::Exception(m,"","DataSvc")     {
    }

    /** Standard Constructor
        @param m : Message error message
        @param t : Tag "name tag", or exeption type
    */
    CacheSvcException(const std::string& m, const std::string& t) 
    : pool::Exception(m,t,"DataSvc")     {
    }
  
    /// destructor (perform the deletion of "previous" field!) 
    virtual ~CacheSvcException() throw() {
    } 
  
    /// No assignment operator
    private:
    CacheSvcException& operator=(const CacheSvcException&);

  };  

}

#endif  
