// $Header: /cvs/POOL/pool/DataSvc/DataSvc/RefException.h,v 1.7 2006/03/13 13:39:59 ioannis Exp $
#ifndef POOL_REFEXCEPTION_H
#define POOL_REFEXCEPTION_H 

#include "POOLCore/Exception.h"
  
namespace pool    {

  /** @class RefException RefException.h pool/RefException.h

      Define generic Exception for Ref misbehavior

      @author Giacomo Govi 
  */
  class RefException : public pool::Exception {
    
    public:
    /** Standard Constructor
        @param m : Message error message
    */
    RefException(const std::string& m) 
    : pool::Exception(m,"","DataSvc")     {
    }

    /** Standard Constructor
        @param m : Message error message
        @param t : Tag "name tag", or exeption type
    */
    RefException(const std::string& m, const std::string& t) 
    : pool::Exception(m,t,"DataSvc")     {
    }
  
    /// destructor (perform the deletion of "previous" field!) 
    virtual ~RefException() throw() {
    } 
  
    /// No assignment operator
    private:
    RefException& operator=(const RefException&);

  };  

}

#endif  // POOL_REFEXCEPTION_H
