#ifndef POOL_PTRHOLDER_H
#define POOL_PTRHOLDER_H 

#include "DataSvc/AnyPtr.h"
#include "RefCounter.h"

namespace pool    {

  class PtrHolder : public AnyPtr, public pool::RefCounter {
      
    public:
 
      PtrHolder(): AnyPtr(), RefCounter(){}

      PtrHolder(const AnyPtr& aPtr) :
	AnyPtr(aPtr), RefCounter() {}

      PtrHolder(const void* aPtr, const std::type_info* aType) :
	AnyPtr(aPtr,aType), RefCounter(){}

      virtual ~PtrHolder(){} 

  };

}

#endif
