// $Header: /cvs/POOL/pool/DataSvc/tests/Common/TestDataObject.h,v 1.6 2003/07/16 13:53:16 govi Exp $
#ifndef POOL_TESTDATAOBJECT_H
#define POOL_TESTDATAOBJECT_H

#include <map>
#include <utility>

namespace pool {

  typedef std::map<long,long> ObjList;

  static ObjList* s_objList = new ObjList;

  class TestDataObject {
  protected:
	
       long objectId;
  public:

	  TestDataObject(): objectId(0){
	    ObjList::iterator iter = s_objList->find(0);
            long cont = 0;
            if(iter != s_objList->end()){
              cont = (*iter).second;
              s_objList->erase(0);
            } 
            cont++;
	    std::pair<long,long> val(0,cont);
            iter = (s_objList->insert(val)).first;
          }

	  TestDataObject(long oId): objectId(oId){
	    ObjList::iterator iter = s_objList->find(oId);
            long cont = 0;
            if(iter != s_objList->end()){
              cont = (*iter).second;
              s_objList->erase(oId);
            } 
            cont++;
	    std::pair<long,long> val(oId,cont);
            iter = (s_objList->insert(val)).first;
          }

          virtual ~TestDataObject(){
	    ObjList::iterator iter = s_objList->find(objectId);
            long count = 0;
            if(iter != s_objList->end()){
              count = (*iter).second;
            } else {
	      std::cout << "ERROR: object not registered\n";
            }
            if(count <= 0){
	      std::cout << "ERROR: object count is"<<count<<"!\n";
            }
            count--;
            s_objList->erase(objectId);
            if(count>0){  
	      std::pair<long,long> val(objectId,count);
              s_objList->insert(val);
            }
          }
    
    long getOId() const {return objectId;}

    virtual bool doJob() const {
      return true;
    }

    static void dumpObjects(){
      ObjList::iterator iter;
      std::cout << "Objects created ->\n";
      for(iter=s_objList->begin();iter!=s_objList->end();++iter){
        long obj_id = (*iter).first;
        long n = (*iter).second;
        std::cout << "ID="<<obj_id<<" N="<<n<<"\n";
      }
      std::cout <<"------------------\n";
    }

	//void print() { std::cout << "Retrieved object: id = " << objectId; }


  };


} // namespace pool
#endif /// TESTDATAOBJECT
