#include<cppunit/extensions/HelperMacros.h>

#include <iostream>
#include "src/DataSvc.h"
#include "src/CacheSvc.h"
#include "src/CacheEntryImp.h"
#include "../Common/TestDataObject.h"
#include "../Common/FakeToken.h"
#include "SealKernel/Status.h"
#include "PersistencySvc/IPersistencySvc.h"
#include "../Common/DummyPersistencySvc.h"

using namespace pool;

/// Unit tests for DataSvc class
class RetrieveTest : public CppUnit::TestFixture 
{

  /// registration of the test class and the specific(s) method to execute
  CPPUNIT_TEST_SUITE( RetrieveTest );
  CPPUNIT_TEST( testRetrieveObj );
  CPPUNIT_TEST_SUITE_END();

public:

   void setUp()
   {  
     ;; //empty 
   }

   void tearDown() 
   {
     ;; //empty
   }

   void testRetrieveObj() {
     const unsigned int NTOK = 1000;
     Token* tokens[NTOK+1];
     CacheEntry* ens[NTOK+1];
     const TestDataObject* objects[NTOK+1];
     IPersistencySvc* thePersSvc = new DummyPersistencySvc;
     DataSvc svc(thePersSvc);
     ICacheSvc* cacheSvc = &svc.cacheSvc();
     unsigned int i=1;
     for(i=1;i<=NTOK;i++){
       tokens[i] = new FakeToken(i);
       ens[i] = cacheSvc->registerToken(*tokens[i]);
       if(!ens[i]){
         std::cout << "Error : returned while registering Token\n"; 
       }
     }
     for(i=1;i<=NTOK;i++){
       long ind = (long)i;
       cacheSvc->getObject(ens[i]);
       CacheEntryImp* entry = dynamic_cast<CacheEntryImp*>(ens[i]);
       objects[i] = 
         reinterpret_cast<const TestDataObject*>(entry->object().constPtr());
       long objId = objects[i]->getOId();
       // cpp unit assertion
       CPPUNIT_ASSERT_EQUAL_MESSAGE("Error found checking ObjId",objId,ind);
     }
   }

};    

/// class registration on cppunit framework
   CPPUNIT_TEST_SUITE_REGISTRATION(RetrieveTest);


#include<CppUnit_testdriver.cpp>
