//$Id: MySQLMetaDataCatalog.h,v 1.3 2005/05/15 12:46:50 xiezhen Exp $
#ifndef POOL_MYSQLMETADATACATALOG_H
#define POOL_MYSQLMETADATACATALOG_H
#ifndef POOL_FCMETAIMPL_H
#include "FileCatalog/FCMetaImpl.h"
#endif
#include "FileCatalog/FCBuf.h"
#include <memory>
namespace pool {
  ///forward declaration
  class FCImpl;
  class MetaDataEntry;
  /**@class MySQLMetaDataCatalog MySQLMetaDataCatalog.h MySQLCatalog/MySQLFileCatalog.h
     Interface to the concrete implementation of the MySQL catalog. 
     @author: Zhen Xie
  */
  class MySQLMetaDataCatalog: public FCMetaImpl{
  public:
    ///Constructor
    MySQLMetaDataCatalog( FCImpl* fc );
    ///Destructor
    virtual ~MySQLMetaDataCatalog();
    virtual void insertMetaData(MetaDataEntry& mentry) const;
    //create meta data schema
    virtual void createMetaDataSpec( MetaDataEntry& schemadef) const;
    //update meta data schema
    virtual void updateMetaDataSpec( MetaDataEntry& schemadef, const FileCatalog::MetaUpdateMode metamode )const;
    virtual void getMetaDataSpec( MetaDataEntry& spec) const;
    ///metadata operations
    //drop the meta data and its definition of the catalog. 
    virtual void dropMetaDataSpec()const;
    virtual void deleteMetaData(const FileCatalog::FileID& guid) const;
    virtual bool retrievePFN(const std::string& query, FCBuf<PFNEntry>& buf, const size_t& start );
    virtual bool retrieveLFN(const std::string& query, FCBuf<LFNEntry>& buf, const size_t& start );
    virtual bool retrieveMetaData(const std::string& query, FCBuf<MetaDataEntry>& buf, const size_t& start );
    virtual bool retrieveGuid(const std::string& query, FCBuf<FileCatalog::FileID>& buf, const size_t& start );
 private:
    struct MySQLMetaDataImpl; //forward declaration
    std::auto_ptr<MySQLMetaDataImpl> m_pimpl; //opaque pointer to private functions
 private:
    void syncConnection() const;
  };
} 
#endif



