#ifndef MYSQLHELPERS_H
#define MYSQLHELPERS_H
#ifndef POOL_SQLPLUS_H
#include <mysql++.h>
#define POOL_SQLPLUS_H
#endif
#include <string>
#include <algorithm>
#include <functional>
#include "FileCatalog/FCEntry.h"
namespace pool{
  /**
     should introduce namespace later
   **/
template <class ColumnType, unsigned int ColumNum >
  struct MySQLextractColumn_n{
    ColumnType operator()(const mysqlpp::Row& row) const {
      return ColumnType(row[ColumNum]);
    }
  };

template <class T>
  struct MySQLconvertRow;

 template <>
   struct MySQLconvertRow<PFNEntry>{
     PFNEntry operator()(const mysqlpp::Row& row) const {
       return PFNEntry(std::string(row.lookup_by_name("pfname")),
                       std::string(row.lookup_by_name("guid")),
                       std::string(row.lookup_by_name("filetype"))
		       );
     }
   };   
     
 template <>
   struct MySQLconvertRow<LFNEntry>{
     LFNEntry operator()(const mysqlpp::Row& row) const {
       return LFNEntry(std::string(row.lookup_by_name("lfname")),std::string(row.lookup_by_name("guid")));
     }    
   };
  
 template <>
   struct MySQLconvertRow<MetaDataEntry>{
     MetaDataEntry operator()(const mysqlpp::Row& /* row */ ) const {
       return MetaDataEntry();
     }    
   };

 struct MySQLconvertString{
   std::string operator()( const std::string& mystr ) const{
     std::string result(mystr);
     result.insert(0,"'");result.append("'");
     return result;
   }
 };
 
 struct MySQLExecute{
   mysqlpp::Connection* m_con;
   MySQLExecute( mysqlpp::Connection* con):m_con(con){}
   void operator()( const std::string& querystr ) const{
     mysqlpp::Query q=m_con->query();
     q<<querystr;
     try{
       q.execute();
     }catch(mysqlpp::BadQuery& er){
       throw er;
     }
   }
 };

 struct MySQLtableExist{
   mysqlpp::Connection* m_con;
   MySQLtableExist( mysqlpp::Connection* con):m_con(con){}
   bool operator()( const std::string& tabname ) const{
     mysqlpp::Query q=m_con->query();
     q<<"show tables";
     mysqlpp::Result res;
     try{
       res=q.store();
       unsigned int n=res.size();
       if(n>0){
	 std::vector<std::string> v;
	 std::transform(res.begin(), res.end(), back_inserter(v), MySQLextractColumn_n<std::string,0>() );
	 std::vector<std::string>::iterator pos=std::find(v.begin(), v.end(), tabname);
	 return pos!=v.end();
       }
       return false;
     } catch (mysqlpp::BadQuery& er){
       throw er;
     }
   }

 };
}//ns pool
#endif
