#include "MySQLImpl.h"

namespace pool{
  MySQLFileCatalog::MySQLImpl::MySQLImpl():m_con(0){
  }
  
  MySQLFileCatalog::MySQLImpl::~MySQLImpl(){
    if( m_con!=0 ) delete m_con;
  }

  void MySQLFileCatalog::MySQLImpl::connect(const std::string& host, const std::string& db, const std::string& user, const std::string& passwd, const int port) {
    try{
      m_con=new mysqlpp::Connection(true);
      m_con->real_connect(db.c_str(),host.c_str(),user.c_str(),passwd.c_str(),port,0,60,"/tmp/mysql.sock",0);
      m_con->query().execute("SET AUTOCOMMIT=0");
    }catch(mysqlpp::BadQuery& er){
      throw er;
    }
  }

  void MySQLFileCatalog::MySQLImpl::disconnect(){
    try{
      m_con->query().execute("COMMIT");
      m_con->close();
      delete m_con;
      m_con=0;
    }
    catch(mysqlpp::BadQuery& er){
      throw er;
    }
  }

  unsigned int MySQLFileCatalog::MySQLImpl::selectfirstPFN(PFNEntry& pentry, const std::string& querystr) const{
    unsigned int n=0;
    mysqlpp::Query q=m_con->query();
    q<<"select * from t_pfn where "<<querystr;
    mysqlpp::Result res;
    try{
      res=q.store();
      n=res.size();
      if ( n>0 ) {
	mysqlpp::Result::iterator i=res.begin();
	std::string mypfn=std::string((*i).lookup_by_name("pfname"));
	std::string myguid=std::string((*i).lookup_by_name("guid"));
	std::string myfiletype=std::string((*i).lookup_by_name("filetype"));
	pentry.setValue(mypfn,myguid,myfiletype);      
      }
    }catch (mysqlpp::BadQuery& er){
      throw er;
    }
    return n;
  }
  
  unsigned int MySQLFileCatalog::MySQLImpl::selectfirstLFN(LFNEntry& lentry, const std::string& querystr) const{
    unsigned n=0;
    mysqlpp::Query q=m_con->query();
    q<<"select * from t_lfn where "<<querystr;
    mysqlpp::Result res;
    try{
      res=q.store();
      n=res.size();
      if ( n>0 ) {
	mysqlpp::Result::iterator i=res.begin();
	std::string mylfn=std::string((*i).lookup_by_name("lfname"));
	std::string myguid=std::string((*i).lookup_by_name("guid"));
	lentry.setValue(mylfn,myguid);
      }
    }catch (mysqlpp::BadQuery& er){
      throw er;
    }
    return n;
  }
}//ns pool
