#ifndef POOL_MYSQLURIPARSER_H
#define POOL_MYSQLURIPARSER_H
#include <string>
#include "FileCatalog/FCException.h"

namespace pool{
  class MySQLURIParser{
  public:
    MySQLURIParser();
    MySQLURIParser(const std::string& url);
    ~MySQLURIParser();
    void dump() const;
    ///Print the protocol
    const std::string protocol() const;
    ///Print the username
    const std::string username() const;
    ///Print the password
    const std::string passwd() const;
    ///Print the host name
    const std::string host() const;
    ///Print the port number
    const unsigned int hostport() const;
    ///Print the absolute file name or the database name 
    const std::string path() const;
    ///Print the URL from the contact string
    const std::string url() const;
    void setURI(const std::string& url);
    void parse() throw (FCillegalContactStringException);
  private:
    std::string m_url;
    std::string m_protocol;
    std::string m_username;
    std::string m_passwd;
    std::string m_host;
    unsigned int m_hostport;
    std::string m_path;
  };
}//ns pool
#endif
