#ifndef MYSQLCATALOG_QUERYPARSER_H
#define MYSQLCATALOG_QUERYPARSER_H

#include <string>
#include <vector>

namespace pool {
    /**
     * @class QueryParser QueryParser.h
     *
     * Utility class for parsing the user submitted queries to the catalog.
     *
     */
  
  class QueryParser {
  public:
    QueryParser( const std::string& whereClause, const std::string& destTab );
    QueryParser( const std::string& whereClause, std::vector<std::string>&metavariables, const std::string& destTab );
    void parse();
    const std::string& parseResult() const;
    const std::string getTablesAsString() const;
    const std::vector<std::string>& getTables() const;
  private:
    std::vector<std::string> m_metavariables;
    std::string m_destTab;
    std::string m_parseResult;
    std::vector<std::string> m_tables;
  private:
    void addTablename(const std::string& varname, const std::string& tabname);
    bool isWithinQuotes( std::string::size_type& varpos ) const;
    bool isWord( const std::string& word, std::string::size_type& varpos ) const;
  };
}//ns pool
#endif
  
