#include "FileCatalog/IFileCatalog.h"
#include "FileCatalog/IFCContainer.h"
#include "FileCatalog/IFCAction.h"
#include "FileCatalog/FCException.h"
using namespace pool;
using namespace std;

int main(){
  
  try{
    const string fileType = "disco";
    
    string con[2] = { "xmlcatalog_file:CollectionCatalog1.xml",
                      "xmlcatalog_file:CollectionCatalog2.xml" };
    string pfn[2] = {"pfn1","pfn2"};
    string guid[2];
    for(int i=0; i<2; ++i){
      IFileCatalog catalog;
      catalog.setWriteCatalog(con[i]);
      catalog.connect();
      FCregister act;
      catalog.setAction(act);
      catalog.start();
      act.registerPFN( pfn[i], fileType, guid[i]);
      catalog.commit();
      catalog.disconnect();
    }
    // connect to the first catalog in write mode
    // to the second one in read mode
    IFileCatalog catalog;
    catalog.setWriteCatalog(con[0]);
    catalog.addReadCatalog(con[1]);
    catalog.connect();
    
    // list the pfns associated with the guids 
    catalog.start();
    FClookup act;
    catalog.setAction(act);
    for(int i=0; i<2; ++i){
      PFNContainer pfns(&catalog);
      act.lookupPFN( guid[i], pfns);
      cerr << guid[i] << endl;
      while(pfns.hasNext()){
        cout << pfns.Next().pfname() << endl;
      }
    } 
    catalog.commit();
    catalog.start();
    GuidContainer g(&catalog);
    act.lookupFileByQuery("",g);
    while( g.hasNext() ){
      cout<< g.Next()<<endl;
    }
    catalog.commit();
    catalog.disconnect();
  }catch( std::exception& e ){
    std::cout << "Exception: " << e.what() << std::endl;
  }
}
