#ifndef POOLCORE_POOLCONTEXT_H
#define POOLCORE_POOLCONTEXT_H

#include <string>
// #include "SealKernel/IMessageService.h" // Seal does not compile with this !!!
#include "SealKernel/MessageStream.h"

namespace seal { class Context; }

namespace pool {

  /// Class defining the entry point to the framework component model for POOL.
  class POOLContext {
  public:
    /// Returns the POOL context.
    static seal::Context* context();

    /// Loads a component identified with a string to the POOL context.
    static void loadComponent( const std::string& componentName );

    /// Sets the verbosity level to the message streams of the POOL components.
    static void setMessageVerbosityLevel( seal::Msg::Level level );
  };

}

#endif
