#include "POOLCore/POOLContext.h"
#include "POOLCore/Exception.h"
#include "PluginManager/PluginManager.h"
#include "SealKernel/ComponentLoader.h"
#include "SealKernel/Context.h"
#include <vector>

seal::Context*
pool::POOLContext::context()
{
  static seal::Handle< seal::Context > s_context = new seal::Context();
  return s_context.get();
}


void
pool::POOLContext::loadComponent( const std::string& componentName )
{
  seal::PluginManager* pm = seal::PluginManager::get();
  if ( ! pm ) {
    throw pool::Exception( "Could not get the plugin manager instance",
                           "POOLContext::loadComponent",
                           "POOLCore" );
  }
  pm->initialise();
  seal::Handle<seal::ComponentLoader> loader = new seal::ComponentLoader( pool::POOLContext::context() );
  loader->load( componentName );
}


void
pool::POOLContext::setMessageVerbosityLevel( seal::Msg::Level level )
{
  std::vector< seal::Handle<seal::IMessageService> > v_msgSvc;
  pool::POOLContext::context()->query( v_msgSvc );
  if ( ! v_msgSvc.empty() ) {
    seal::Handle<seal::IMessageService>& msgSvc = v_msgSvc.front();
    msgSvc->setOutputLevel( level );
  }
}
