#include <iostream>
#include <exception>
#include "POOLCore/Exception.h"
#include "POOLCore/PoolMessageStream.h"
#include "POOLCore/POOLContext.h"


int main( int, char** ) {
  try {

    // Loading the seal message service
    pool::POOLContext::loadComponent( "SEAL/Services/Message Service" );
    pool::POOLContext::setMessageVerbosityLevel( seal::Msg::Nil );

    // Creating an using the message stream
    pool::PoolMessageStream msgstream( "main" );

    msgstream << seal::Msg::Verbose << "This is a verbose message" << seal::flush;
    msgstream << seal::Msg::Debug << "This is a debug message" << seal::flush;
    msgstream << seal::Msg::Info << "This is an info message" << seal::flush;
    msgstream << seal::Msg::Warning << "This is a warning message" << seal::flush;
    msgstream << seal::Msg::Error << "This is an error message" << seal::flush;
    msgstream << seal::Msg::Fatal << "This is a fatal message" << seal::flush;

    // Setting the threshold level to Error
    pool::POOLContext::setMessageVerbosityLevel( seal::Msg::Error );

    // Creating an using the message stream
    pool::PoolMessageStream msgstream2( "main2" );

    msgstream2 << seal::Msg::Verbose << "This is a verbose message" << seal::flush;
    msgstream2 << seal::Msg::Debug << "This is a debug message" << seal::flush;
    msgstream2 << seal::Msg::Info << "This is an info message" << seal::flush;
    msgstream2 << seal::Msg::Warning << "This is a warning message" << seal::flush;
    msgstream2 << seal::Msg::Error << "This is an error message" << seal::flush;
    msgstream2 << seal::Msg::Fatal << "This is a fatal message" << seal::flush;

  }
  catch( pool::Exception& poolError ) {
    std::cerr << "POOL Exception : " << poolError.what() << std::endl;
    return 1;
  }
  catch( std::exception& error ) {
    std::cerr << error.what() << std::endl;
    return 1;
  }
  catch( ... ) {
    std::cerr << "Error of unknown source..." << std::endl;
  }
  return 0;
}
