// This file's extension implies that it's C, but it's really -*- C++ -*-.
// $Id: ICollectionSize.h,v 1.1.2.2 2007/11/28 13:19:25 roiser Exp $
/**
 * @file  ICollectionSize.h
 * @author scott snyder <snyder@bnl.gov>
 * @date May, 2005
 * @brief Abstract interface for finding the size of an event collection.
 */

#ifndef INCLUDE_PERSISTENCYSVC_ICOLLECTIONSIZE_H
#define INCLUDE_PERSISTENCYSVC_ICOLLECTIONSIZE_H

namespace pool {


/**
 * @class ICollectionSize
 * @brief Abstract interface for finding the size of an event collection.
 */
class ICollectionSize
{
public:
  /**
   * @brief Destructor.
   */
  virtual ~ICollectionSize () {};


  /**
   * @brief Return the size of the collection.
   */
  virtual long long int size () = 0;
};


} // namespace pool


#endif // not INCLUDE_PERSISTENCYSVC_ICOLLECTIONSIZE_H
