#ifndef PERSISTENCYSVC_DATATRANSFORM_H
#define PERSISTENCYSVC_DATATRANSFORM_H

#include "PersistencySvc/IDataTransform.h"
#include "Reflex/Type.h"
#include "POOLCore/Guid.h"
#include <map>

namespace pool {
  namespace PersistencySvc {
    class DataTransform : public virtual IDataTransform {
    public:
      DataTransform();
      ~DataTransform();
      
      // Methods from IDataTransform that have to be implemented
      void setAutomaticCallBackCreation( bool flag = true );

      DataCallBack& transformation( const pool::Guid& object_type,
                                    const ROOT::Reflex::Type& shape_type );

      DataCallBack& transformation( const ROOT::Reflex::Type& object_type,
                                    const ROOT::Reflex::Type& shape_type );

      bool registerTransformation( const pool::Guid& object_type,
                                   const ROOT::Reflex::Type& shape_type,
                                   const DataCallBack& callback );

      bool registerTransformation( const ROOT::Reflex::Type& object_type,
                                   const ROOT::Reflex::Type& shape_type,
                                   const DataCallBack& callback );

      bool deregisterTransformation( const pool::Guid& object_type, 
                                     const ROOT::Reflex::Type& shape_type );

      bool deregisterTransformation( const ROOT::Reflex::Type& object_type, 
                                     const ROOT::Reflex::Type& shape_type );
    private:
      bool m_automaticCreationFlag;
      std::map< pool::Guid, std::map< ROOT::Reflex::Type, DataCallBack* > > m_callBackObjects;
      std::map< ROOT::Reflex::Type, std::map< ROOT::Reflex::Type, DataCallBack* > > m_callBackObjectsTransientType;
    };
  }
}

#endif
