#include "PersistencySvc/DatabaseConnectionPolicy.h"
#include "POOLCore/PoolMessageStream.h"

bool
pool::DatabaseConnectionPolicy::setWriteModeForExisting( pool::DatabaseConnectionPolicy::Mode mode )
{
  if ( mode == pool::DatabaseConnectionPolicy::CREATE ) {
    pool::PoolMessageStream log( "PersistencySvc::DatabaseConnectionPolicy" );
    log << seal::Msg::Error << "CREATE is not allowed as an option in setWriteModeForExisting()" << seal::endmsg;
  }
  else if ( mode == pool::DatabaseConnectionPolicy::READ ) {
    pool::PoolMessageStream log( "PersistencySvc::DatabaseConnectionPolicy" );
    log << seal::Msg::Error << "READ is not allowed as an option in setWriteModeForExisting()" << seal::endmsg;
  }
  else {
    if ( mode == pool::DatabaseConnectionPolicy::RAISE_ERROR ||
         mode == pool::DatabaseConnectionPolicy::UPDATE ||
         mode == pool::DatabaseConnectionPolicy::OVERWRITE ) {
      m_writeModeForExisting = mode;
      return true;
    }
    else {
      pool::PoolMessageStream log( "PersistencySvc::DatabaseConnectionPolicy" );
      log << seal::Msg::Error << "Unrecognizable option specified in setWriteModeForExisting()" << seal::endmsg;
    }
  }
  return false;
}

bool
pool::DatabaseConnectionPolicy::setWriteModeForNonExisting( pool::DatabaseConnectionPolicy::Mode mode )
{
  if ( mode ==  pool::DatabaseConnectionPolicy::READ ) {
    pool::PoolMessageStream log( "PersistencySvc::DatabaseConnectionPolicy" );
    log << seal::Msg::Error << "READ is not allowed as an option in setWriteModeForNonExisting()" << seal::endmsg;
  }
  else if ( mode == pool::DatabaseConnectionPolicy::OVERWRITE ) {
    pool::PoolMessageStream log( "PersistencySvc::DatabaseConnectionPolicy" );
    log << seal::Msg::Error << "OVERWRITE is not allowed as an option in setWriteModeForExisting()" << seal::endmsg;
  }
  else {
    if ( mode == pool::DatabaseConnectionPolicy::RAISE_ERROR ||
         mode == pool::DatabaseConnectionPolicy::CREATE ||
         mode == pool::DatabaseConnectionPolicy::UPDATE ) {
      m_writeModeForNonExisting = mode;
      return true;
    }
    else {
      pool::PoolMessageStream log( "PersistencySvc::DatabaseConnectionPolicy" );
      log << seal::Msg::Error << "Unrecognizable option specified in setWriteModeForNonExisting()" << seal::endmsg;
    }
  }
  return false;
}

bool
pool::DatabaseConnectionPolicy::setReadMode( pool::DatabaseConnectionPolicy::Mode mode )
{
  if ( mode == pool::DatabaseConnectionPolicy::CREATE ) {
    pool::PoolMessageStream log( "PersistencySvc::DatabaseConnectionPolicy" );
    log << seal::Msg::Error << "CREATE is not allowed as an option in setReadMode()" << seal::endmsg;
  }
  else if ( mode == pool::DatabaseConnectionPolicy::OVERWRITE ) {
    pool::PoolMessageStream log( "PersistencySvc::DatabaseConnectionPolicy" );
    log << seal::Msg::Error << "OVERWRITE is not allowed as an option in setReadMode()" << seal::endmsg;
  }
  else if ( mode == pool::DatabaseConnectionPolicy::RAISE_ERROR ) {
    pool::PoolMessageStream log( "PersistencySvc::DatabaseConnectionPolicy" );
    log << seal::Msg::Error << "RAISE_ERROR is not allowed as an option in setReadMode()" << seal::endmsg;
  }
  else {
    if ( mode == pool::DatabaseConnectionPolicy::READ ||
         mode == pool::DatabaseConnectionPolicy::UPDATE ) {
      m_readMode = mode;
      return true;
    }
    else {
      pool::PoolMessageStream log( "PersistencySvc::DatabaseConnectionPolicy" );
      log << seal::Msg::Error << "Unrecognizable option specified in setReadMode()" << seal::endmsg;
    }
  }
  return false;
}
