#ifndef INCLUDE_PERSISTENCYSVC_IGLOBALTRANSACTION_H
#define INCLUDE_PERSISTENCYSVC_IGLOBALTRANSACTION_H

#include "PersistencySvc/ITransaction.h"

namespace pool {

  // forward declarations
  class ITransactionObserver;

  namespace PersistencySvc {
    /** @class IGlobalTransaction
     *
     *  IGlobalTransaction extends the basic ITransaction base class to allow observers
     *  to be registered.
     *
     */
    
    class IGlobalTransaction : public ITransaction {
    protected:
      /// Default destructor
      virtual ~IGlobalTransaction() {}

    public:
      /// Registers an observer
      virtual bool registerObserver( ITransactionObserver& observer ) = 0;
      
      /// Deregisters an observer
      virtual bool deregisterObserver( ITransactionObserver& observer ) = 0;
    };

  }
}

#endif
