import sys, DLFCN
sys.setdlopenflags( DLFCN.RTLD_NOW | DLFCN.RTLD_GLOBAL )
from FileCatalog import *
import PyFCBuf, PyFileCatalog

class PyFCContainer(object):
    def __init__(self,cat, containerType, cacheMax=1000):
        self.buf=PyFCBuf.PyFCBuf(cacheMax)
        self.containerType=containerType
        self.catalog=cat
        self.cachemax=cacheMax #fixme: redundant para 
        self.finish=0
        self.current=0
        self.nrcatalogs=cat.nReadCatalogs()
        self.currentcatalog=0
        self.querystatus=0
        self.query=""
        self.wdone='false'
        self.rdone='false'
        self.me=0
    def reset(self):
        self.buf.clear()
        self.finish=0
        self.current=0
        self.currentcatalog=0
        self.querystatus=0
        self.query=""
        self.wdone='false'
        self.rdone='false'
        self.me=0
    def type(self):
        return self.containerType
    def hasNext(self):
        result=0
        if self.wdone is 'false':
           self.me=self.catalog.getWriteCatalog() 
           if self.me is 0:
               self.wdone='true'
           else:
               result=self.hasNextInternal(self.me, self.query)
               if self.querystatus==0:#noResult
                   self.wdone='true';
               if self.querystatus==1:#lastResult
                   if result==0:
                       self.wdone='true'
                   else:
                       #self.wdone='true'
                       return result
               if self.querystatus==2:#hasResult
                   return result
        if self.wdone is 'true':
            if self.currentcatalog == self.nrcatalogs:
                return 0
            if self.rdone is 'false':
                self.me=self.catalog.getReadCatalog(self.currentcatalog)
                self.buf.clear()
                self.current=0
                self.finish=0
                result=self.hasNextInternal(self.me, self.query)
                self.rdone='true'
            else:   
                #if self.currentcatalog != self.nrcatalogs:                
                result=self.hasNextInternal(self.me, self.query)
            if self.querystatus==0: #noResult
                if self.gotoNextCatalog() == 1:
                    return self.hasNext()
                else:
                    return 0
            if self.querystatus==1: #lastResult
                if result==0:
                    if self.gotoNextCatalog() == 1:
                        return self.hasNext()
                    else:
                        return 0
                else:
                    return result
            if self.querystatus==2: #hasResult
                return result
        return 0
    
    def hasNextInternal(self, cat, query):
        if self.buf.isBoundary(self.current):
            self.buf.clear()
            result=[]
            if self.containerType==PFN:
                #print query, self.buf.data(), self.current
                result=cat.retrievePFN(query,self.current,self.cachemax)
                self.buf.fillbuf(result)
            elif self.containerType==LFN:
                result=cat.retrieveLFN(query,self.current,self.cachemax)
                self.buf.fillbuf(result)
            elif self.containerType==META:
                result=cat.retrieveMetaData(query,self.current,self.cachemax)
                self.buf.fillbuf(result)
            elif self.containerType==GUID:
                result=cat.retrieveGuid(query,self.current,self.cachemax)
                self.buf.fillbuf(result)
            if len(result)!=0:
                self.finish=self.buf.size()
                if self.finish<self.buf.maxsize():
                    self.querystatus=1#lastResult
                else:
                    self.querystatus=2#has Result
                return 1
            else:
                self.querystatus=0
                return 0
        else:
            temppos=self.current-(self.buf.nBoundary(self.current))*self.cachemax
            if temppos!=self.finish:
                return 1
            else:
                return 0
        
    def Next(self):
        temppos=self.current-(self.buf.nBoundary(self.current))*self.cachemax
        self.current=self.current+1
        return self.buf[temppos]
    def maxsize(self):
        return self.cachemax
    def setQuery(self, query):
        self.query=query
    def gotoNextCatalog(self):
        if self.currentcatalog==self.nrcatalogs:
            return 0
        else:
            self.currentcatalog=self.currentcatalog+1
            self.buf.clear()
            self.current=0
            self.finish=0
            self.querystatus=0
            self.rdone='false'
            return 1
if __name__=="__main__":
    x=PyFileCatalog.PyFileCatalog()
    x.setWriteCatalog('xmlcatalog_file:sample.xml')
    pfns=PyFCContainer(x,PFN)
    pfns.setQuery('pfname=pippo')

