import sys
if sys.platform != 'win32':
  import DLFCN
  sys.setdlopenflags( DLFCN.RTLD_NOW | DLFCN.RTLD_GLOBAL )
  from liblcg_PyFileCatalog import *
  import liblcg_PyFileCatalog
  __doc__=liblcg_PyFileCatalog.__doc__
  del liblcg_PyFileCatalog
  del DLFCN
else:
  from lcg_PyFileCatalog import *
  import lcg_PyFileCatalog
  __doc__=lcg_PyFileCatalog.__doc__
  del lcg_PyFileCatalog
del sys

    
class PyFileCatalog(object):
    def __init__(self):
        self.wchild=0
        self.rchildren=[]
    def setWriteCatalog(self, contactstr):
        self.wchild=PyFCImpl(contactstr)
    def addReadCatalog(self, contactstr):
        self.rchildren.append(PyFCImpl(contactstr))
    def getReadCatalogs(self):
        #print 'getReadCatalogs', self.rchildren
        return self.rchildren
    def nReadCatalogs(self):
        return len(self.rchildren)
    def getReadCatalog(self, idx):
        return self.rchildren[idx]
    def getWriteCatalog(self):
        return self.wchild
    
    def importCatalog(self, sourcefc, query='', cacheSize=1000):
        #if self.wchild.isReadOnly():
        #    print 'is readonly'
        try:
            importmeta=1
            m=self.wchild.hasMetaDataCatalog()
            metasource=sourcefc.hasMetaDataCatalog()
            if m==0 or metasource==0:
               importmeta=0
            else: 
               metaspec=self.wchild.getMetaDataSpec()
               if len(metaspec)<=1:
                  importmeta=0
            nreadcatalogs=[]
            nreadcatalogs=sourcefc.getReadCatalogs()
            for x in nreadcatalogs: 
                pcounter=0
                lcounter=0
                pbuf=x.retrievePFN(query,pcounter,cacheSize)
                pbufsize=len(pbuf)
                while pbufsize!=0:
                    for i in range(pbufsize):
                        try:
                            self.wchild.insertPFN(pbuf[i][0],pbuf[i][1],pbuf[i][2])
                        except PyFileCatalogError, er:
                            if er.__str__().find('PFN is not unique')!=-1:
                                print '[Warning] skip importing duplicate PFN',pbuf[i][0]
                                break
                    pcounter+=cacheSize
                    pbuf=x.retrievePFN(query,pcounter,cacheSize)
                    pbufsize=len(pbuf)
                lbuf=x.retrieveLFN(query,lcounter,cacheSize)
                lbufsize=len(lbuf)
                while lbufsize!=0:
                    for i in range(lbufsize):
                        try:
                            self.wchild.insertLFN(lbuf[i][0],lbuf[i][1])
                        except PyFileCatalogError, er:
                            if er.__str__().find('LFN is not unique')!=-1:
                                print '[Warning] skip importing duplicate LFN',lbuf[i][0]
                                break
		    lcounter+=cacheSize
                    lbuf=x.retrieveLFN(query,lcounter,cacheSize)
                    lbufsize=len(lbuf)
                if importmeta!=0:
                    mcounter=0
                    mbuf=x.retrieveMetaData(query,mcounter,cacheSize)
                    mbufsize=len(mbuf)
                    while mbufsize!=0:
                      for i in range(mbufsize):
                          try:
                            self.wchild.insertMetaData(mbuf[i]['guid'], mbuf[i])
                          except PyFileCatalogError, er:
                            if er.__str__().find('guid-metadata entry already exists')!=-1:
                                print '[Warning] skip importing duplicate guid-metadata entry',mbuf[i]['guid']
                                break
                      mcounter+=cacheSize
                      mbuf=x.retrieveMetaData(query,mcounter,cacheSize)
                      mbufsize=len(mbuf)
            cat=sourcefc.getWriteCatalog()
            if cat!=0 :
                pcounter=0
                pbuf=cat.retrievePFN(query,pcounter,cacheSize)
                pbufsize=len(pbuf)
                while pbufsize!=0:
                    for i in range(pbufsize):
                        try:
                            self.wchild.insertPFN(pbuf[i][0],pbuf[i][1],pbuf[i][2])
                        except PyFileCatalogError, er:
                            if er.__str__().find('PFN is not unique')!=-1:
                                print '[Warning] skip importing duplicate PFN',pbuf[i][0]
                                break
                    pcounter+=cacheSize
                    pbuf=cat.retrievePFN(query,pcounter,cacheSize)
                    pbufsize=len(pbuf)
                lcounter=0;
                lbuf=cat.retrieveLFN(query,lcounter,cacheSize)
                lbufsize=len(lbuf)
                while lbufsize!=0:
                    for i in range(lbufsize):
                        try:
                            self.wchild.insertLFN( lbuf[i][0], lbuf[i][1] )
                        except PyFileCatalogError, er:
                            if er.__str__().find('LFN is not unique')!=-1:
                                print '[Warning] skip importing duplicate LFN',lbuf[i][0]
                                break
                    lcounter+=cacheSize
                    lbuf=cat.retrieveLFN(query,lcounter,cacheSize)
                    lbufsize=len(lbuf)
                if importmeta!=0:
                    mcounter=0;
                    mbuf=cat.retrieveMetaData(query,mcounter,cacheSize)
                    mbufsize=len(mbuf)
                    while mbufsize!=0:
                      for i in range(mbufsize):
                         try:
                            self.wchild.insertMetaData(mbuf[i]['guid'], mbuf[i])
                         except PyFileCatalogError, er:
                            if er.__str__().find('guid-metadata entry already exists')!=-1:
                                print '[Warning] skip importing duplicate guid-metadata entry',mbuf[i]['guid']
                                break
                      mcounter+=cacheSize
                      mbuf=cat.retrieveMetaData(query,mcounter,cacheSize)
                      mbufsize=len(mbuf)

        except PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:',er
            
    def connect(self):
        try:
            if self.wchild:
                self.wchild.connect()
            if len(self.rchildren)!=0:
                [ x.connect() for x in self.rchildren ]
        except PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:',er
            
    def disconnect(self):
        try:
            if len(self.rchildren)!=0:
                self.rchildren.reverse()
                [ x.disconnect() for x in self.rchildren ]
            if self.wchild:
                self.wchild.disconnect()
        except PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:',er
            
    def start(self):
        try:
            if self.wchild:
                self.wchild.start()
            if len(self.rchildren)!=0:
                [ x.start() for x in self.rchildren ]
        except PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:',er
            
    def commit(self,commitmode=REFRESH):
        try:
            if len(self.rchildren)!=0:
                self.rchildren.reverse()
                [ x.commit(commitmode) for x in self.rchildren ]
            if self.wchild:
                self.wchild.commit(commitmode)
        except PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:',er
            
    def rollback(self):
        try:
            if len(self.rchildren)!=0:
                self.rchildren.reverse()
                [ x.rollback() for x in self.rchildren ]
            if self.wchild:
                self.wchild.rollback()
        except PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:',er
            
    def totalLeaf(self):
        if self.wchild:
            return len(self.rchildren)+1
        else:
            return len(self.rchildren)
    def setAction(self, act):
        if self.totalLeaf()==0: return
        if self.totalLeaf()==1:
            act.visitFCLeaf(self)
        else:
            act.visitFCComposite(self)
    def hasMetaDataCatalog(self):
        hasmeta=1
        if self.wchild:
	   if self.wchild.hasMetaDataCatalog()==0:
              hasmeta=0
        if len(self.rchildren)!=0:
           if self.rchildren[0].hasMetaDataCatalog()==0:
              hasmeta=0 
        return hasmeta
if __name__=="__main__":
    try:
        x=PyFileCatalog()
        x.setWriteCatalog('xmlcatalog_file:sample.xml')
        x.addReadCatalog('xmlcatalog_file:test1.xml')
        x.addReadCatalog('xmlcatalog_file:test2.xml')
        x.connect()
        x.disconnect()
    except PyFileCatalogError, er:
        print 'PyFileCatalogError Caught:',er
        
