#import sys, DLFCN
#sys.setdlopenflags( DLFCN.RTLD_NOW | DLFCN.RTLD_GLOBAL )
from PyFileCatalog import *
import unittest,os
cat='file:explicitstr.xml'
#cat='mysqlcatalog_mysql://xiezhen@localhost/zhendb'
#cat='edgcatalog_http://rlstest.cern.ch:7777/test/v2.2/edg-local-replica-catalog/services/edg-local-replica-catalog'
class ConnectTest(unittest.TestCase):
    def testNULLenvPOOCATALOG(self):
        print '[OVAL]testNULLenvPOOCATALOG'
        os.unsetenv('POOL_CATALOG')
        try:
            x=PyFileCatalog()
            x.setWriteCatalog("")
            self.assertEqual(x.connect(),None,'cannot connect')
            self.assertEqual(x.start(),None,'cannot start')
            self.assertEqual(x.commit(),None,'cannot commit')
            self.assertEqual(x.disconnect(),None,'cannot disconnect')
            self.assertEqual(os.path.exists('./PoolFileCatalog.xml'),1)
            os.remove('./PoolFileCatalog.xml')
        except PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:',er
            x.rollback()
            
    def testWITHenvPOOCATALOG(self):
        print '[OVAL]testWITHenvPOOCATALOG'
        os.putenv('POOL_CATALOG','file:withenv.xml')
        try:
            x=PyFileCatalog()
            x.setWriteCatalog("")
            self.assertEqual(x.connect(),None,'cannot connect')
            self.assertEqual(x.start(),None,'cannot start')
            self.assertEqual(x.commit(REFRESH),None,'cannot commit')
            self.assertEqual(x.disconnect(),None,'cannot disconnect')
            self.assertEqual(os.path.exists('./withenv.xml'),1)
            os.remove('./withenv.xml')
        except PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:',er
            x.rollback()
            
    def testexplicitcontact(self):
        print '[OVAL]testexplicitcontact'
        try:
            x=PyFileCatalog()
            x.setWriteCatalog(cat)
            self.assertEqual(x.connect(),None,'cannot connect')
            self.assertEqual(x.start(),None,'cannot start')
            self.assertEqual(x.commit(ONHOLD),None,'cannot commit ONHOLD')
            self.assertEqual(x.start(),None,'cannot start')
            self.assertEqual(x.commit(REFRESH),None,'cannot commit REFRESH')
            self.assertEqual(x.disconnect(),None,'cannot disconnect')
        except PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:',er
            x.rollback()
            
    def testmultipleconnect(self):
	print '[OVAL]testmultipleconnect'	
        try:
            x=PyFileCatalog()
            x.setWriteCatalog("")
            x.addReadCatalog(cat)
            x.addReadCatalog('file:test.xml')
            self.assertEqual(x.connect(),None,'cannot connect')
            self.assertEqual(x.start(),None,'cannot start')
            self.assertEqual(x.commit(ONHOLD),None,'cannot commit ONHOLD')
            self.assertEqual(x.start(),None,'cannot start')
            self.assertEqual(x.commit(REFRESH),None,'cannot commit REFRESH')
            self.assertEqual(x.disconnect(),None,'cannot disconnect')
        except PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:',er
            x.rollback()
            
if __name__=='__main__':
    unittest.main()
