from PyFileCatalog import *
from PyFCContainer import *
from PyFCAction import *
import unittest
########################################################################
#test import without metadata.
#the source catalog should be prepared with populateSampleCatalog.py
########################################################################
source=PyFileCatalog.PyFileCatalog()
#source.setWriteCatalog('mysqlcatalog_mysql://xiezhen@localhost/FCtest')
source.addReadCatalog('mysqlcatalog_mysql://xiezhen@localhost/FCtest')
#source.setWriteCatalog('file:sample.xml')
#source.addReadCatalog('file:sample.xml')
dest=PyFileCatalog.PyFileCatalog()
dest.setWriteCatalog('mysqlcatalog_mysql://xiezhen@localhost/zhendb')
#dest.setWriteCatalog('file:importdest.xml')
def clean_start(d,s):
    print '[OVAL] clean_start'	
    try:
        d.connect()
        s.connect()
    except PyFileCatalogError, er:
        print 'PyFileCatalogError Caught:',er
        s.rollback()
        d.rollback()
    try:
        d.start()
        l=PyFClookup()
        a=PyFCAdmin()
        d.setAction(l)
        d.setAction(a)
        p=PyFCContainer.PyFCContainer(d,GUID)
        l.lookupFileByQuery('',p)
        while( p.hasNext() ):
            guid=p.Next()
            a.deleteEntry(guid)
        d.commit()
    except PyFileCatalogError, er:
        print 'PyFileCatalogError Caught:',er
        d.rollback()
            
class importTest(unittest.TestCase):
    def setUp(self):
        print '[OVAL] setUp'
        clean_start(dest,source)
    def tearDown(self):
	print '[OVAL] tearDown'
        dest.disconnect()
        source.disconnect()
    def testDefaultimport(self):
        print '[OVAL] testDefaultimport'
        try:
            dest.start()
            source.start()
            a=PyFCAdmin()
            source.setAction(a)
            ad=PyFCAdmin()
            dest.setAction(ad)
	    print 1
            dest.importCatalog(source)
	    print 2
            self.assertEqual(ad.lookupBestPFN('guid0')['pfn'],'pfn0')
            self.assertEqual(ad.lookupBestPFN('guid9')['pfn'],'pfn9')
            source.commit()
            dest.commit()
        except PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:',er
            source.rollback()
            dest.rollback()

    def testEmptyQueryimport(self):
        print '[OVAL] testEmptyQueryimport'
        try:
            dest.start()
            source.start()
            a=PyFCAdmin()
            source.setAction(a)
            ad=PyFCAdmin()
            dest.setAction(ad)
            dest.importCatalog(source,'')
            self.assertEqual(ad.lookupBestPFN('guid0')['pfn'],'pfn0')
            self.assertEqual(ad.lookupBestPFN('guid9')['pfn'],'pfn9')
            dest.importCatalog(source,'') # test skip duplicate entry
            source.commit()
            dest.commit()
        except PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:',er
            source.rollback()
            dest.rollback()
            
    def testQueryimport(self):
        print '[OVAL]testQueryimport'
        try:
            dest.start()
            source.start()
            a=PyFCAdmin()
            source.setAction(a)
            ad=PyFCAdmin()
            dest.setAction(ad)
            dest.importCatalog(source,"guid='guid0'")
            self.assertEqual(ad.lookupBestPFN('guid0')['pfn'],'pfn0')
            self.assertEqual(ad.lookupBestPFN('guid1')['pfn'],'')
            source.commit()
            dest.commit()
        except PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:',er
            source.rollback()
            dest.rollback()

if __name__=='__main__':
    unittest.main()
