from PyFileCatalog import *
from PyFCContainer import *
from PyFCAction import *
import unittest
#catsrc='file:importsource_metadiff.xml'
catsrc='mysqlcatalog_mysql://xiezhen@localhost/zhendb'
#catdest='file:importdest_metadiff.xml'
#catdest='edgcatalog_http://rlstest:7777/v2.2/test/edg-local-replica-catalog/services/edg-local-replica-catalog'
catdest='mysqlcatalog_mysql://xiezhen@localhost/FCtest'
dest=PyFileCatalog.PyFileCatalog()
dest.setWriteCatalog(catdest)
source=PyFileCatalog.PyFileCatalog()
source.setWriteCatalog(catsrc)

pfns=['pfnname_0','pfnname_1','pfnname_2']
lfns=[i+'_lfn' for i in pfns]
def clean_start(d,s):
        print 'clean_start'
        counter=0
        for c in d,s:
            counter=counter+1
            try:
	        l=PyFClookup()
		a=PyFCAdmin()
		c.setAction(l)
		c.setAction(a)
                c.connect()
                c.start()
                p=PyFCContainer.PyFCContainer(c,GUID)
                l.lookupFileByQuery('',p)
                while( p.hasNext() ):
		    guid=p.Next()
		    #print "deleting entry: ",guid
                    a.deleteEntry(guid)
		a.dropMetaDataSpec()
                c.commit()
                c.start()
                c.commit()
            except PyFileCatalog.PyFileCatalogError, er:
                print 'PyFileCatalogError Caught:',er
                c.rollback()
class diffschemaimportTest(unittest.TestCase):
    def setUp(self):
        print '[OVAL] setUp'
        clean_start(dest,source)
        
    def tearDown(self):
        print '[OVAL] tearDown'	
        dest.disconnect()
        source.disconnect()
        
    def testImportToEmptyMetaCatalog(self):
        print '[OVAL] testImportToEmptyMetaCatalog'
        try:
            fids=list()
            spec={'a':'string','b':'string'}
            source.start()
	    l=PyFClookup()
	    a=PyFCAdmin()
	    r=PyFCregister()
	    source.setAction(l)
	    source.setAction(a)
	    source.setAction(r)
            a.createMetaDataSpec(spec)
            source.commit()
            source.start()
            for pfn in pfns:
                fid=r.registerPFN(pfn,'root_all')
                fids.append(fid)
                r.registerLFN(pfn,lfns[pfns.index(pfn)])
                r.registerMetaData(fid,{'a':pfn+'avalue','b':pfn+'bvalue'})
            source.commit()
            
            source.start()
            dest.start()
            dl=PyFClookup()
            dest.setAction(dl)
            dest.importCatalog(source,'pfname='+'\''+pfns[0]+'\'')
            source.commit()
            dest.commit()

            source.start()
            dest.start()
	    dl=PyFClookup()
	    da=PyFCAdmin()
	    dest.setAction(dl)
	    source.setAction(da)
	    #print dl.getMetaDataSpec()
            #print l.getMetaDataSpec()
            self.assertNotEqual(dl.getMetaDataSpec(),l.getMetaDataSpec())
            i=0
            self.assertEqual(dl.lookupBestPFN(fids[i])['pfn'],pfns[i])
            self.assertEqual(l.lookupBestPFN(fids[i])['pfn'],pfns[i])
            self.assertEqual(dl.lookupFileByLFN(lfns[i]), fids[i])
            source.commit()
            dest.commit()

            dest.setAction(da)
            source.start()
            dest.start()
            da.createMetaDataSpec(spec)
            self.assertEqual(dl.getMetaDataSpec(),l.getMetaDataSpec())
            dest.importCatalog(source,'pfname='+'\''+pfns[1]+'\'')
            self.assertEqual(dl.lookupBestPFN(fids[1])['pfn'],pfns[1])
            self.assertEqual(l.lookupBestPFN(fids[1])['pfn'],pfns[1])
            self.assertNotEqual(dl.lookupBestPFN(fids[2])['pfn'],pfns[2])
            dest.commit()
            source.commit()
            print 'ImportToEmptyCatalog done'
        except PyFileCatalog.PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:',er
            dest.rollback()
            source.rollback()
    def testImportFromEmptyMetaCatalog(self):
        print '[OVAL] testImportFromEmptyMetaCatalog'
        try:
            source.start()
            fids=list()
	    r=PyFCregister()
	    source.setAction(r)
            for pfn in pfns:
                fid=r.registerPFN(pfn,'root_all')
                fids.append(fid)
                r.registerLFN(pfn,lfns[pfns.index(pfn)])
            source.commit()
            source.start()
            dest.start()
            spec={'a':'string','b':'string'}
	    da=PyFCAdmin()
	    dest.setAction(da)
            da.createMetaDataSpec(spec)
            dest.importCatalog(source)
            #print 'lookup result',fids[0], dest.lookupBestPFN(fids[0])
            self.assertEqual(da.lookupBestPFN(fids[0])['pfn'],pfns[0])
            source.commit()
            dest.commit()
            print 'testImportFromEmptyMetaCatalog done'
        except PyFileCatalog.PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:',er
            source.rollback()
            dest.rollback()
        
    def testImportDiffSchemaCatalog(self):
        print '[OVAL] testImportDiffSchemaCatalog'
        try:
            spec={'a':'string','b':'string'}
            source.start()
	    sa=PyFCAdmin()
	    source.setAction(sa)
	    sr=PyFCregister()
	    source.setAction(sr)
            sa.createMetaDataSpec(spec)
            fids=[]
            for pfn in pfns:
                fid=sr.registerPFN(pfn,'root_all')
		print "registered", fid,pfn
                fids.append(fid)
                sr.registerLFN(pfn,pfn+'_lfn')
		print "registered LFN"
                sr.registerMetaData(fid,{'a':pfn+'avalue','b':pfn+'bvalue'})
		print "registered Meta"
            source.commit()

            destspec={'a':'string'}
            dest.start()
	    da=PyFCAdmin()
	    dest.setAction(da)
	    dr=PyFCregister()
	    dest.setAction(dr)
	    dl=PyFClookup()
	    dest.setAction(dl)
            da.createMetaDataSpec(destspec)
            for pfn in pfns:
                fid=dr.registerPFN(pfn+'dest','root_all')
                dr.registerLFN(pfn+'dest',pfn+'dest'+'_lfn')
                dr.registerMetaData(fid,{'a':pfn+'dest'+'avalue'})
            dest.commit()
            source.start()
            dest.start()
            #prepairing dest schema
            destspec.update(spec)
            da.updateMetaDataSpec(destspec)
            dest.importCatalog(source) 
            self.assertEqual(dl.lookupBestPFN(fids[0])['pfn'],pfns[0])
            self.assertEqual(dl.getMetaDataSpec(),sa.getMetaDataSpec())
	    dest.commit()
            source.commit()
            dest.start()
            results=PyFCContainer.PyFCContainer(dest,META,200)
            dl.lookupMetaDataByQuery('',results)
            while(results.hasNext()):
                print results.Next()
            dest.commit()
	    print 'testImportDiffSchemaCatalog done'	
        except PyFileCatalog.PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:',er
            source.rollback()
            dest.rollback()
if __name__=='__main__':
    unittest.main()    
                
