from PyFileCatalog import *
from PyFCContainer import *
from PyFCAction import *
import unittest
#dest=FileCatalog('mysqlcatalog_mysql://xiezhen@localhost/zhendb')
#dest=FileCatalog('edgcatalog_http://rlstest:7777/test/edg-local-replica-catalog/services/edg-local-replica-catalog')
source=PyFileCatalog.PyFileCatalog()
source.setWriteCatalog('mysqlcatalog_mysql://xiezhen@localhost/FCtest')
#source.setWriteCatalog('file:sample.xml')
dest=PyFileCatalog.PyFileCatalog()
dest.setWriteCatalog('file:importdest.xml')
#dest.setWriteCatalog('mysqlcatalog_mysql://xiezhen@localhost/zhendb')
def clean_start(d,s):
    try:
        print '[OVAL] clean_start'
        d.connect()
        s.connect()
    except PyFileCatalog.PyFileCatalogError, er:
        print 'PyFileCatalogError Caught:',er
        s.rollback()
        d.rollback()
    try:
        d.start()
        l=PyFClookup()
        a=PyFCAdmin()
        d.setAction(l)
        d.setAction(a)
        p=PyFCContainer.PyFCContainer(d,GUID)
        l.lookupFileByQuery('',p)
        while( p.hasNext() ):
            guid=p.Next()
            a.deleteEntry(guid)
        a.dropMetaDataSpec()
        d.commit()
    except PyFileCatalog.PyFileCatalogError, er:
        print 'PyFileCatalogError Caught:',er
        d.rollback()
            
class importTest(unittest.TestCase):
    def setUp(self):
	print '[OVAL] setUp'	
        clean_start(dest,source)
    def tearDown(self):
        print '[OVAL] tearDown'
        dest.disconnect()
        source.disconnect()
    def testDefaultimport(self):
        print '[OVAL] testDefaultimport'
        try:
            dest.start()
            source.start()
            a=PyFCAdmin()
            source.setAction(a)
            spec=a.getMetaDataSpec()
            ad=PyFCAdmin()
            dest.setAction(ad)
            ad.createMetaDataSpec(spec)
            dest.importCatalog(source)
            self.assertEqual(ad.lookupBestPFN('guid0')['pfn'],'pfn0')
            self.assertEqual(ad.lookupBestPFN('guid9')['pfn'],'pfn9')
            self.assertEqual(ad.getMetaDataSpec(), a.getMetaDataSpec())
            source.commit()
            dest.commit()
        except PyFileCatalog.PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:',er
            source.rollback()
            dest.rollback()

    def testEmptyQueryimport(self):
        print '[OVAL] testEmptyQueryimport'
        try:
            dest.start()
            source.start()
            a=PyFCAdmin()
            source.setAction(a)
            spec=a.getMetaDataSpec()
            ad=PyFCAdmin()
            dest.setAction(ad)
            ad.createMetaDataSpec(spec)
            dest.importCatalog(source,'')
            self.assertEqual(ad.lookupBestPFN('guid0')['pfn'],'pfn0')
            self.assertEqual(ad.lookupBestPFN('guid9')['pfn'],'pfn9')
            self.assertEqual(ad.getMetaDataSpec(), a.getMetaDataSpec())
            dest.importCatalog(source,'') # test skip duplicate entry
            source.commit()
            dest.commit()
        except PyFileCatalog.PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:',er
            source.rollback()
            dest.rollback()
            
    def testQueryimport(self):
        print '[OVAL]testQueryimport'
        try:
            dest.start()
            source.start()
            a=PyFCAdmin()
            source.setAction(a)
            spec=a.getMetaDataSpec()
            ad=PyFCAdmin()
            dest.setAction(ad)
            ad.createMetaDataSpec(spec)
            dest.importCatalog(source,"guid='guid0'")
            self.assertEqual(ad.lookupBestPFN('guid0')['pfn'],'pfn0')
            self.assertEqual(ad.lookupBestPFN('guid1')['pfn'],'')
            self.assertEqual(ad.getMetaDataSpec(), a.getMetaDataSpec())
            source.commit()
            dest.commit()
        except PyFileCatalog.PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:',er
            source.rollback()
            dest.rollback()

if __name__=='__main__':
    unittest.main()
