from PyFileCatalog import *
from PyFCContainer import *
from PyFCAction import *
import os
class copymeta(object):
    def __init__(self, contactstr):
        '''constructor. define the CMS metadata schema and connect to the catalog.'''
        self.catalog=PyFileCatalog.PyFileCatalog()
        self.catalog.setWriteCatalog(contactstr)
        self.r=PyFCregister()
        self.catalog.setAction(self.r)
        self.inputdata=[]
        try:
            self.catalog.connect()
        except PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:', er
            
    def __del__(self):
        '''destructor. disconnect from the catalog.'''
        try:
            self.catalog.disconnect()
        except PyFileCatalogError, er:
            print 'PyFileCatalogError Caught:', er
            
    def parsefile(self,filename):
        for line in open(filename):
            self.inputdata.append((line.split(' ')[7], line.split(' ')[10]) )
        #print self.inputdata[0][0], self.inputdata[0][1]

    def parsemetastring(self,metastr):
        s="".join(metastr.split("("))
        s="".join(s.split("),"))
        s="".join(s.split(")"))
        s="".join(s.split("'\n"))
        cmsitems=['Content','DBoid','DataType','FileCategory','Flags','dataset','jobid','owner','runid']
        i=0
        endidx=0
        result={}
        for item in cmsitems:
            begidx=s.find(item)+len(item)+1
            i=i+1
            try:
                endidx=s.find(cmsitems[i])
            except IndexError:
                endidx=len(s)
            if (begidx!=-1) and (endidx!=-1):
                value=s[begidx:endidx]
                if value=='NULL': value=''
                result[item]=value
        return result
    
    def setMapping(self):
        try:
            self.catalog.start()
            for entry in self.inputdata:
                lfn=entry[0]
                metastr=entry[1]
                metadatadict=self.parsemetastring(metastr)
                #print 'METADICT', metadatadict
                guid=self.catalog.wchild.lookupFileByLFN(lfn)
                #print 'guid', guid
                metadatadict['guid']=guid
                #print 'lfn', lfn
                self.catalog.wchild.insertMetaData(guid,metadatadict)
            self.catalog.commit()
        except PyFileCatalogError, er:
            print er
            self.catalog.rollback()
        
            
if __name__=="__main__":
    x=copymeta('xmlcatalog_file:mu03-saved.xml')
    x.parsefile('meta-fix.mu03_W1mu')
    x.setMapping()
