#include <iostream>
#include "TServerSocket.h"
#include "TFile.h"
#include "TMessage.h"
#include "TTree.h"
#include "TEventList.h"

using namespace std;

void server(){
  
  const unsigned int maxStrLen = 1024;
  
  TServerSocket *servSock = new TServerSocket(4223, kTRUE);
  
  TFile* file = 0;
  
  while(1){
    
    if(file){
      delete file;
      file = 0;
    }
    
    cerr << "Waiting for a client ..." << endl;
    TSocket* sock = servSock->Accept();
    TInetAddress adr = sock->GetInetAddress();
    cerr << "Yeah, a new client: ";
    adr.Print();
    cerr << "Waiting for filename ... " << endl;
    TMessage *mess;
    sock->Recv(mess);
    
    char fileName[maxStrLen];
    if (mess->What() == kMESS_STRING){
      mess->ReadString(fileName, maxStrLen);  
      cerr << "File Name: " << fileName << endl;
    }else{
      cerr << "can't handle message, kick the client out" << endl;
      sock->Close();
      continue;
    }
    delete mess;
    
    cerr << "Waiting for selection string ..." << endl;
    sock->Recv(mess);
    char selStr[maxStrLen];
    if (mess->What() == kMESS_STRING){
      mess->ReadString(selStr, maxStrLen);  
      cerr << "Selection String: " << selStr << endl;
    }else{
      cerr << "can't handle message, kick the client out" << endl;
      sock->Close();
      continue;
    }
    delete mess;
    
    cerr << "Open File: " << fileName << " ..." << endl; 
    file = TFile::Open(fileName);
    if(!file || file->IsZombie()){
      cerr << "can't open file, kick the client out" << endl; 
      sock->Send("get lost, sucker");
      sock->Close();
      continue;
    }
    
    TTree* tree = dynamic_cast<TTree*>(file->Get("CollectionTree"));
    if(!tree){
      cerr << "can't retrieve the tree, kick the client out" << endl; 
      sock->Send("get lost, sucker");
      sock->Close();
      continue;
    }
    
    cerr << "Performing the selection ..." << endl;
    int rows = tree->Draw(">>evlList", selStr);
    if(rows<0){
      cerr << "selection failed, kick the client out" << endl; 
      sock->Send("get lost, sucker");
      sock->Close();
      continue;
    }
    
    TEventList* evlList = dynamic_cast<TEventList*>(gROOT->FindObject("evlList"));
    if(!evlList){
      cerr << "ups , kick the client out" << endl; 
      sock->Send("get lost, sucker");
      sock->Close();
      continue;
    }else
      cerr << evlList->GetN()
	   << " entries has been selected" 
	   << endl;
    
    cerr << "Sending the event list" << endl;
    sock->SendObject(evlList);
    cerr << "The eventList has been sent.\n" << endl;
    
    //cin >> fileName;
    
    delete evlList;
    
    sock->Close();
  }
}
