//====================================================================
//
//	Package    : RootStorageSvc (The POOL project)
//
//	Author     : M.Frank
//====================================================================
#ifndef POOL_ROOTSTORAGESVC_CUSTOMSTREAMER_H
#define POOL_ROOTSTORAGESVC_CUSTOMSTREAMER_H 1

#include "RootStorageSvc/StreamerBase.h"

/*
 *   POOL namespace declaration
 */
namespace pool  {  

  // Forward declarations
  class ICINTStreamer;

  /**@class CustomStreamer CustomStreamer.h src/CustomStreamer.h
    *
    * Specialized streamer to handle Object I/O with custom streamers
    *
    *  @author  M.Frank
    *  @version 1.0
    *  @date    11/11/2004
    */
  class CustomStreamer : public StreamerBase  {
    /// Reference to streamer function
    ICINTStreamer*  m_streamer;

  public:
    /// Initializing constructor
    CustomStreamer(const TypeH& typ, TClass* cl, ICINTStreamer* s);
    /// ROOT I/O callback
    virtual void operator()(TBuffer &b, void *obj);
  };
}
#endif // POOL_ROOTSTORAGESVC_IOHANDLERCUSTOMSTREAMER_H
