#ifndef POOL_ROOTSTORAGESVC_ICINTSTREAMERFACTORY_H
#define POOL_ROOTSTORAGESVC_ICINTSTREAMERFACTORY_H

#include "RootStorageSvc/ICINTStreamer.h"
#include "PluginManager/PluginFactory.h"
#include "Reflex/Type.h"

/*
 *    POOL namespace declaration
 */
namespace pool {

  /**@class ICINTStreamerFactory ICINTStreamerFactory.h RootStorageSvc/ICINTStreamerFactory.h
    *
    *  Implement SEAL plugin model for SEAL 1.4.0\
    *
    *  @author  M.Frank
    *  @version 1.0
    */
  struct ICINTStreamerFactory 
    : public seal::PluginFactory< ICINTStreamer* (const ROOT::Reflex::Type&) >
  {
    static ICINTStreamerFactory* get();
    ICINTStreamerFactory();
  };
}

// Reflex object factory definition
#include "Reflex/PluginService.h"
namespace {
  template < typename P > class Factory<P, pool::ICINTStreamer*(ROOT::Reflex::Type)> {
  public: static void* Func( void*, const std::vector<void*>& arg, void*) 
    { return (pool::ICINTStreamer*)(new P(*(ROOT::Reflex::Type*)arg[0]));   }
  };
}
#define DECLARE_CINTSTREAMER(x) PLUGINSVC_FACTORY(x,pool::ICINTStreamer*(ROOT::Reflex::Type))

#endif // POOL_ROOTSTORAGESVC_ICINTSTREAMERFACTORY_H
