//====================================================================
//
//	Package    : RootStorageSvc (The POOL project)
//
//	Author     : M.Frank
//====================================================================
#ifndef POOL_ROOTSTORAGESVC_IOHANDLERCUSTOMSTREAMER_H
#define POOL_ROOTSTORAGESVC_IOHANDLERCUSTOMSTREAMER_H 1

#include "RootStorageSvc/StreamerBase.h"

/*
 *   POOL namespace declaration
 */
namespace pool  {  

  // Forward declarations
  class IIOHandler;
  class ICINTStreamer;

  /**@class IOHandlerCustomStreamer IOHandlerCustomStreamer.h src/IOHandlerCustomStreamer.h
    *
    * Specialized streamer to handle Object I/O with
    * custom streamers and I/O handler.
    *
    *  @author  M.Frank
    *  @version 1.0
    *  @date    11/11/2004
    */
  class IOHandlerCustomStreamer : public StreamerBase  {
    /// Reference to streamer function
    ICINTStreamer*  m_streamer;
    /// Reference to I/O handler
    IIOHandler*     m_ioHandler;

  public:
    /// Initializing constructor
    IOHandlerCustomStreamer(const TypeH& typ, TClass* cl, IIOHandler* h, ICINTStreamer* s);
    /// ROOT I/O callback
    virtual void operator()(TBuffer &b, void *obj);
  };
}
#endif // POOL_ROOTSTORAGESVC_IOHANDLERCUSTOMSTREAMER_H
