//====================================================================
//
//	Package    : RootStorageSvc (The POOL project)
//
//	Author     : M.Frank
//====================================================================
#ifndef POOL_ROOTSTORAGESVC_IOHANDLERSTREAMER_H
#define POOL_ROOTSTORAGESVC_IOHANDLERSTREAMER_H 1

#include "RootStorageSvc/StreamerBase.h"

/*
 *   POOL namespace declaration
 */
namespace pool { 

  // Forward declarations
  class IIOHandler;

  /**@class RefStreamer CINTRefStreamer.h RootStorageSvc/CINTRefStreamer.h
    *
    * Specialized streamer to handle Object I/O with I/O handler.
    *
    *  @author  M.Frank
    *  @version 1.0
    *  @date    11/11/2004
    */
  class IOHandlerStreamer : public StreamerBase  {
    /// Reference to I/O handler
    IIOHandler* m_ioHandler;

  public:
    /// Initializing constructor
    IOHandlerStreamer(const TypeH& typ, TClass* cl, IIOHandler* h);
    /// ROOT I/O callback
    virtual void operator()(TBuffer &b, void *obj);
  };
}
#endif // POOL_ROOTSTORAGESVC_IOHANDLERSTREAMER_H
