#ifndef IROOTKEYIOHANDLERFACTORY_H
#define IROOTKEYIOHANDLERFACTORY_H

#include "RootStorageSvc/IRootKeyIOHandler.h"
#include "PluginManager/PluginFactory.h"

/*
 *    POOL namespace declaration
 */
namespace pool {

  /**@class ICINTStreamerFactory ICINTStreamerFactory.h RootStorageSvc/ICINTStreamerFactory.h
    *
    *  Implement SEAL plugin model for SEAL 1.4.0
    *
    *  @author  M.Frank
    *  @version 1.0
    */
  struct IRootKeyIOHandlerFactory : public seal::PluginFactory<IRootKeyIOHandler* ()>  {
    static IRootKeyIOHandlerFactory* get();
    IRootKeyIOHandlerFactory();
  };
}

// Reflex object factory definition
#include "Reflex/PluginService.h"
namespace {
  template <typename P> class Factory<P, pool::IRootKeyIOHandler*()> {
    public: static void* Func( void*, const std::vector<void*>& arg, void*) 
    { return (pool::IRootKeyIOHandler*)(new P());  }
  };
}
#define DECLARE_CINTSTREAMER(x) PLUGINSVC_FACTORY(x,pool::IRootKeyIOHandler*())

#endif
