//====================================================================
//
//	Package    : RootStorageSvc (The POOL project)
//
//	Author     : M.Frank
//====================================================================
#ifndef POOL_ROOTSTORAGESVC_STREAMERBASE_H
#define POOL_ROOTSTORAGESVC_STREAMERBASE_H 1

#include "TClassStreamer.h"
#include "Reflex/Type.h"
class TClass;

/*
 *   POOL namespace declaration
 */
namespace pool  {

  /**@class StreamerBase StreamerBase.h RootStorageSvc/StreamerBase.h
    *
    * Specialized streamer to handle POOL references.
    *
    *  @author  M.Frank
    *  @version 1.0
    *  @date    11/11/2004
    */
  class StreamerBase : public TClassStreamer  {
  public:
    typedef ROOT::Reflex::Type TypeH;
    typedef void (*Streamer_t)(const TypeH&, TBuffer&, void*, int);
  protected:
    /// LCG Reflection type
    TypeH     m_type;
    /// ROOT persistent class description
    TClass*   m_root;

  public:
    /// Initializing constructor
    StreamerBase(const TypeH& typ, TClass* cl);
    /// ROOT I/O callback
    virtual void operator()(TBuffer &b, void *obj);
  };
}
#endif // POOL_ROOTSTORAGESVC_STREAMERBASE_H
