//====================================================================
//	Root Database factories implementation
//--------------------------------------------------------------------
//
//	Package    : POOLCore/RootDb (The POOL project)
//
//	Author     : M.Frank
//====================================================================
#include "PluginManager/ModuleDef.h"
DEFINE_SEAL_MODULE();

#include "StorageSvc/DbType.h"
#include "StorageSvc/IOODatabaseFactory.h"
#include "RootOODb.h"
DEFINE_SEAL_PLUGIN( pool::IOODatabaseFactory , pool::RootOODb, pool::ROOT_StorageType.storageName() );
DEFINE_SEAL_PLUGIN( pool::IOODatabaseFactory , pool::RootOOKey, pool::ROOTKEY_StorageType.storageName() );
DEFINE_SEAL_PLUGIN( pool::IOODatabaseFactory , pool::RootOOTree, pool::ROOTTREE_StorageType.storageName() );

struct ROOT_All : public pool::RootOODb{ ROOT_All(void* c) : RootOODb(c)   {}};
struct ROOT_Tree: public pool::RootOODb{ ROOT_Tree(void* c): RootOODb(c,pool::ROOTTREE_StorageType){}};
struct ROOT_Key : public pool::RootOODb{ ROOT_Key(void* c) : RootOODb(c,pool::ROOTKEY_StorageType) {}};

DECLARE_OODATABASE(ROOT_All)
DECLARE_OODATABASE(ROOT_Tree)
DECLARE_OODATABASE(ROOT_Key)
