#include "StorageSvc/pool.h"
#include "Reflex/Builder/ClassBuilder.h"
#include "TPluginManager.h"
#include "TMemFile.h"
#include "TROOT.h"
using namespace ROOT::Reflex;

typedef const std::vector<void*>& _Args;
template <class T> static void* ctor(void* m,_Args,void*)  {  return ::new(m) T();      }
template <class T> static void* dtor(void* m,_Args,void*)  {  ((T*)m)->~T(); return 0;  }
static void* TMemFile_ctor(void* mem, _Args args, void*)
{  return ::new(mem) TMemFile((const char*)args[0],(const char*)args[1],(const char*)args[2],*(int*)args[3]);  }
static void* TMemFile_dumpFile(void* mem, _Args args, void*)
{  static int p; p=((TMemFile*)mem)->dumpFile((const char*)args[0]);  return &p; }
static void* TMemFile_destroyFile(void* mem, _Args args, void*)
{  static int p; p=((TMemFile*)mem)->destroyFile((const char*)args[0]);  return &p; }
static void* TMemFile_listFiles(void* mem, _Args, void*)
{  static int p; p=((TMemFile*)mem)->listFiles();  return &p; }
static void* TMemFile_clearFiles(void* mem, _Args, void*)
{  static int p; p=((TMemFile*)mem)->clearFiles();  return &p; }


POOL_BEGIN_STATIC_BLOCK(TMemFile)
    ClassBuilderT<TFile>()
      .AddFunctionMember<void(void)>("TFile",  ctor<TFile>, 0, 0, PUBLIC | CONSTRUCTOR )
      .AddFunctionMember<void(void)>("~TFile", dtor<TFile>, 0, 0, PUBLIC | DESTRUCTOR );

    ClassBuilderT<TSystem>()
      .AddFunctionMember<void(void)>("TSystem",  ctor<TSystem>, 0, 0, PUBLIC | CONSTRUCTOR )
      .AddFunctionMember<void(void)>("~TSystem", dtor<TSystem>, 0, 0, PUBLIC | DESTRUCTOR );

    ClassBuilderT<TMemFile>()
      .AddBase<TFile>()
      .AddFunctionMember<void(void)>("TMemFile",  ctor<TMemFile>, 0, 0, PUBLIC | CONSTRUCTOR )
      .AddFunctionMember<void(void)>("~TMemFile", dtor<TMemFile>, 0, 0, PUBLIC | DESTRUCTOR )
      .AddFunctionMember<void(const char*,const char*,const char*,int)>("TMemFile", TMemFile_ctor, 0, 0, PUBLIC | CONSTRUCTOR )
      .AddFunctionMember<int(const char*)>("dumpFile", TMemFile_dumpFile, 0, 0, PUBLIC )
      .AddFunctionMember<int(const char*)>("destroyFile", TMemFile_destroyFile, 0, 0, PUBLIC )
      .AddFunctionMember<int(void)>("listFiles", TMemFile_listFiles, 0, 0, PUBLIC )
      .AddFunctionMember<int(void)>("clearFiles", TMemFile_clearFiles, 0, 0, PUBLIC );
    gROOT->GetPluginManager()->AddHandler("TFile","^memfile","TMemFile", "lcg_RootStorageSvc", "TMemFile(const char*,const char*,const char*,int)");

    ClassBuilderT<TMemSystem>()
      .AddBase<TSystem>()
      .AddFunctionMember<void(void)>("TMemSystem",  ctor<TMemSystem>, 0, 0, PUBLIC | CONSTRUCTOR )
      .AddFunctionMember<void(void)>("~TMemSystem", dtor<TMemSystem>, 0, 0, PUBLIC | DESTRUCTOR );
    gROOT->GetPluginManager()->AddHandler("TSystem","^memfile","TMemSystem", "lcg_RootStorageSvc", "TMemSystem()");
POOL_END_STATIC_BLOCK(TMemFile)
