//====================================================================
//
//  Package    : StorageSvc (The POOL project)
//
//  Author     : M.Frank
//====================================================================
#ifndef POOL_DBDATAHANDLERGUARD_H
#define POOL_DBDATAHANDLERGUARD_H

/*
 *   POOL namespace declaration
 */
namespace pool {

  // Forward declarations
  class DbDatabase;
  class DataCallBack;
  class DbDefaultDataHandler;

  /** @class DataLoadHandler
    *
    * Description:
    * Small class to allow interception load actions of objects
    */
  class DbDataHandlerGuard  {
  protected:
    /// Keep reference to data handler if present
    DbDefaultDataHandler* m_handler;
  public:
    /// Standard Constrcutor; sets the caller environment
    DbDataHandlerGuard(DataCallBack* caller, 
                       DbDatabase*   dbH);
    /// Standard Constrcutor; releases the caller environment
    ~DbDataHandlerGuard();
    /// Access to current handler
    static pool::DataCallBack* caller();
  };
}
#endif // POOL_DBDATAHANDLERGUARD_H
