// $Id: IDbOptionProxy.h,v 1.7 2007/11/28 16:19:32 frankb Exp $
//
//  Package    : pool/StorageSvc (The pool framework)
//
//  @author      M.Frank
//
//====================================================================
#ifndef POOL_IDBOPTIONPROXY_H
#define POOL_IDBOPTIONPROXY_H
// $Header: /cvs/POOL/pool/StorageSvc/StorageSvc/IDbOptionProxy.h,v 1.7 2007/11/28 16:19:32 frankb Exp $

// Framework include files
#include "StorageSvc/pool.h"

/*
 *   POOL namespace declaration
 */
namespace pool    {

  // Forward declarations
  class DbOption;

  /** @class IDbOptionProxy IDbOptionProxy.h StorageSvc/IDbOptionProxy.h 
    *
    * Description:
    *
    * Interface to the implementation specific part of a container object
    * objects.
    *
    * @author  M.Frank
    * @version 1.0
    */
  class IDbOptionProxy    {
  protected:
    /// Destructor (called only by sub-classes)
    virtual ~IDbOptionProxy()   {     }

  public:
    /// Set options
    /** @param refOpt   [IN]  Reference to option object.
      *
      * @return DbStatus code indicating success or failure.  
      */
    virtual DbStatus setOption(const DbOption& refOpt) = 0;

    /// Access options
    /** @param refOpt   [IN]  Reference to option object.
      *
      * @return DbStatus code indicating success or failure.  
      */
    virtual DbStatus getOption(DbOption& refOpt) const = 0;
  };
}      // End namespace pool
#endif // POOL_IDBOPTIONPROXY_H
