#ifndef IOODATABASEFACTORY_H
#define IOODATABASEFACTORY_H

#include "StorageSvc/IOODatabase.h"
#include "PluginManager/PluginFactory.h"

/*
 *    POOL namespace declaration
 */
namespace pool {

  /**@class IOODatabaseFactory IOODatabaseFactory.h StorageSvc/IOODatabaseFactory.h
    *
    *  Implement SEAL plugin model for SEAL 1.4.0
    *
    *  @author  M.Frank
    *  @version 1.0
    */
  struct IOODatabaseFactory : public seal::PluginFactory< IOODatabase* (void*) >  {
    static IOODatabaseFactory* get();
    IOODatabaseFactory();
  };
}

#include "Reflex/PluginService.h"
// Reflex object factory definition
namespace {
  template <typename P> class Factory<P,pool::IOODatabase*(void*)> {
    public: static void* Func( void*, const std::vector<void*>& arg, void*) 
    { return (pool::IOODatabase*)(new P(arg[0]));                   }
  };
}
#define DECLARE_OODATABASE(x) PLUGINSVC_FACTORY(x,pool::IOODatabase*(void*))
#endif
