#ifndef ISTORAGESVCFACTORY_H
#define ISTORAGESVCFACTORY_H

#include "StorageSvc/IStorageSvc.h"
#include "PluginManager/PluginFactory.h"

/*
 *    POOL namespace declaration
 */
namespace pool {

  /**@class IStorageSvcFactory IStorageSvcFactory.h StorageSvc/IStorageSvcFactory.h
    *
    *  Implement SEAL plugin model for SEAL 1.4.0
    *
    *  @author  M.Frank
    *  @version 1.0
    */
  class IStorageSvcFactory 
  : public seal::PluginFactory< IStorageSvc* (void*, const std::string&) >  {
  public:
    /// Factory accessor
    static IStorageSvcFactory* get();
    /// Standard constructor
    IStorageSvcFactory();
  };
}
#endif
