// $Id: DbDomainImp.cpp,v 1.12 2007/11/20 16:43:09 frankb Exp $
//====================================================================
//
//  Package    : StorageSvc (The POOL project)
//
//  @author      M.Frank
//
//====================================================================

/// Framework include files
#include "StorageSvc/DbDomainImp.h"
#include "StorageSvc/DbInstanceCount.h"
#include "StorageSvc/DbOptionCallback.h"
using namespace pool;

/// Standard Constructor
DbDomainImp::DbDomainImp(IOODatabase* idb) : DbImplementation(idb)  {
  DbInstanceCount::increment(this);
}

/// Standard Destructor
DbDomainImp::~DbDomainImp() {
  DbInstanceCount::decrement(this);
}

/// Open domain
DbStatus DbDomainImp::open( const DbSession&   /* sesH  */, 
                            const std::string&    nam     , 
                            DbAccessMode       /* mod   */)
{
  return DbOptionCallback::getOptions(this, DbOptionCallback::_DOMAIN_OPT, nam);
}

/// Set domain specific options
DbStatus DbDomainImp::setOption(const DbOption&  /* refOpt */)  {
  return Error;  
}

/// Access domain specific options
DbStatus DbDomainImp::getOption(DbOption&        /* refOpt */) const  {
  return Error;  
}
