// $Id: DbObjectGuard.cpp,v 1.9 2007/11/20 16:43:10 frankb Exp $
//====================================================================
//  DbObjectGuard handle implementation
//--------------------------------------------------------------------
//
//  Package    : StorageSvc  (The POOL project)
//  @author      M.Frank
//====================================================================

#include "StorageSvc/DbObjectGuard.h"
#include "StorageSvc/DbInstanceCount.h"
using namespace pool;

/// Destructor
DbObjectGuard::~DbObjectGuard()   {
  DbInstanceCount::decrement(this);
}

/// Standard constructor
DbObjectGuard::DbObjectGuard(int type, int siz) 
: m_size(siz),
  m_refCount(0), 
  m_destruct(0),
  m_container(type),
  m_oid(INVALID,INVALID)
{ 
  DbInstanceCount::increment(this);
}

/// Standard constructor
DbObjectGuard::DbObjectGuard(const DbContainer& cntH, int siz)
: m_size(siz),
  m_refCount(0),
  m_destruct(0),
  m_container(cntH),
  m_oid(INVALID,INVALID)
{ 
  DbInstanceCount::increment(this);
}
