#ifndef DataModel_H
#define DataModel_H
#include <vector>
#include <utility>
#include <map>

#include "DataSvc/Ref.h"

namespace ext {

 class ooObj {

 public:

   ooObj():m_id(0){}

   ooObj(unsigned int i):m_id(i){}

  virtual ~ooObj(){}

  unsigned int id() const { return m_id; }
  
 private:

  unsigned int m_id;

 };

class ooScopeObj : public ooObj {

 public:


  ooScopeObj():ooObj(0),m_map(),m_label(){}

  ooScopeObj(unsigned int id,std::string label):ooObj(id),m_map(),m_label(label){}

 virtual ~ooScopeObj(){}

 const std::map<std::string, pool::Ref<ext::ooScopeObj> >& objMap() const { return m_map; }

 std::map<std::string, pool::Ref<ext::ooScopeObj> >& objMap() { return m_map; }

 const std::string& label() const { return m_label;}

 private:

  std::map<std::string, pool::Ref<ext::ooScopeObj> > m_map;

  std::string m_label;

};
 

}
#endif
