#ifndef DataModel_H
#define DataModel_H
#include<vector>
#include<utility>

#include "DataSvc/Ref.h"

namespace ext {

  struct Obj {
        virtual ~Obj(){}

  };

  struct A {
    A() : ok(1) {}
    unsigned char ok;
    pool::Ref<Obj> d;

  };


  struct Id {
    Id(){}
    Id(int ir, int ie): r(ir), e(ie){}

    int r;
    int e;
  };

  struct B : public A{
    B(){}
    B(Id ia,Id ib) : a(ia), b(ib), s(0), cs(0), w(false){}
    Id a;
    Id b;
    unsigned int s;
    unsigned int cs;
    bool w;
  };

  
  struct IColl : public Obj {
    virtual size_t size() const=0;
  };

  
  struct MyColl : public IColl {
    typedef std::pair<B,pool::Ref<Obj> > Elem;
    typedef std::vector<Elem> Coll;

    virtual ~MyColl(){}
    virtual size_t size() const { return me.size();}
    Coll me;

  };


  struct S{};

  template<typename E, typename T> 
  struct BColl : public IColl {
    virtual ~BColl(){}
    virtual const pool::Ref<T> & first() const=0;

  };

  template<typename E, typename T> 
  struct TColl : public  BColl<E,T> {
    typedef std::pair<E,pool::Ref<T> > Elem;
    typedef std::vector<Elem> Coll;

    virtual ~TColl(){}
    virtual size_t size() const { return me.size();}
    virtual const pool::Ref<T> & first() const { return me.front().second;}
    Coll me;

  };
  

}
#endif
