#include "TestBase/TestBase.h"
#include "StorageSvc/DbType.h"
#include "StorageSvc/poolDb.h"
#include <vector>

namespace pool  {

  class CrossReferenceTest : public TestBase {
    private:
    const std::string m_dbName;
    const DbType m_type;
    std::string m_fid;
    
    std::vector<std::string> m_tokens;

    public: 
    CrossReferenceTest(std::string& dbName, const DbType& storage_type);

    /// write objects to the persistent store
    // Do to the cross reference, the write operation cannot be perfomed in two nested transactions -
    // (when the first is committed, the corrispondent cache location is resetted)
    // This type of use case can be handled only trough a single transaction.
    void write(unsigned int NC);

    /// read objects from the persistent store
    void read(unsigned int n_expected);

    void execute();
  };

}

