#include "DataSvc/Ref.h"
#include "TNamed.h"
#include <string>

class TreeClass  {

 private:

  long m_id;
  
  std::string m_name;

  pool::Ref<const TNamed > refNamed;

  pool::Ref<const TreeClass> m_tree;

  static long next() 
    { static long cnt=0; return ++cnt; }

  bool equals(const TNamed& t1,const TNamed& t2) const {
    bool ret = true;
    if(::strcmp(t1.GetTitle(),t2.GetTitle())>0) ret = false;
    if(::strcmp(t1.GetName(),t2.GetName())>0) ret = false;
    return ret;
  }

 public:

  TreeClass(const long val):m_id(val){} 

  TreeClass(): m_id(next()){}

  virtual ~TreeClass(){}
 
  const long id() const {
    return m_id;
  }

  const std::string name(){
    return m_name;
  }

  void setName(const std::string& aName){
    m_name = aName;
  }

  const TNamed* named() const {
    return refNamed;
  }

  void setTNamed(const TNamed* pObj)        {
    refNamed = pObj;
  }

  const TreeClass* nextTree() const {
    return m_tree;
  }

  void setNext(const TreeClass* aTree){
    m_tree = aTree;
  }

  bool operator==(const TreeClass& aTreeObject) const {
    bool ret = true;
    if(m_id!=aTreeObject.m_id)     ret = false;
    if(m_name!=aTreeObject.m_name) ret = false;
    if(!refNamed){
      if(aTreeObject.refNamed) ret = false;
    } else {
      if(!aTreeObject.refNamed){
        ret = false;
      } else {
        if(!equals(*refNamed,*(aTreeObject.refNamed))) ret = false;
      }
    }
    return ret;
  }

  void dump() const {
    std::cout << "Id="<<m_id<<std::endl;
    std::cout << "Name="<<m_name<<std::endl;
    if(refNamed){
      std::cout << "Ref Name="<<refNamed->GetName()<<std::endl;
      std::cout << "Ref Title="<<refNamed->GetTitle()<<std::endl;
    }
  }

};

