#include "TestBase/TestBase.h"
#include "StorageSvc/DbType.h"
#include "StorageSvc/poolDb.h"
#include <map>

class RootPtrMemberClass;
class ObjectPtrMemberClass;

namespace pool  {

class PtrMemberTest : public TestBase {
  private:
    const std::string m_dbName;
    const DbType m_type;
    std::string m_fid;
    std::map<std::string,pool::Guid> m_guidMap;

    bool compareExpected(unsigned int i,const RootPtrMemberClass& obj);
    bool compareExpected(unsigned int i,const ObjectPtrMemberClass& obj);

  public: 
    PtrMemberTest(std::string& dbName, const DbType& storage_type);
    /// write objects to the persistent store
    void write(unsigned int NC);

    /// read objects from the persistent store
    void reWrite(unsigned int NC);

    /// read objects from the persistent store
    void read(unsigned int n_expected);

    void execute(){ 
      write(1000);
      read(1000);
    }

};

}


