#include "CMSFileManagerBase/CatalogPopulator.h"
#include "CMSFileManagerBase/CatalogLookups.h"
#include "FileCatalog/FCSystemTools.h"
#include "POOLCore/POOLContext.h"

int main(){
  pool::POOLContext::loadComponent( "SEAL/Services/Message Service" );
  pool::POOLContext::setMessageVerbosityLevel( seal::Msg::Info );
  if( !pool::FCSystemTools::FileExists("xmlcatalog.xml") ){
    CatalogPopulator m;
    m.openCatalog("file:xmlcatalog.xml");
    m.defineSchema();
    m.populateCatalogFromfile("/afs/cern.ch/sw/lcg/app/pool/reference_data/testing_input/FileCatalog_CMSFileManager/cataloginput.txt");
    m.closeCatalog();
  }
  CatalogLookups l;
  l.openCatalog("file:xmlcatalog.xml");
  std::vector<std::string> lfns;
  l.getMETAfiles("CARF_System","",lfns);
  l.getEVDfiles("FakeRecA2","","Collections",lfns);
  l.getOtherfiles("JobControl","FakeRecA2",lfns);
  std::vector<std::string>::iterator ibeg(lfns.begin());
  std::vector<std::string>::iterator iend(lfns.end());
  for(std::vector<std::string>::iterator i=ibeg; i!=iend; ++i){
    std::cout<<"[OVAL] "<<(*i)<<std::endl;
  }
  lfns.clear();
  l.getFilesByOwner("TestPileup",lfns);
  ibeg=lfns.begin(); iend=lfns.end();
  std::cout<<"============================="<<std::endl;
  for(std::vector<std::string>::iterator i=ibeg; i!=iend; ++i){
    std::cout<<"[OVAL] "<<(*i)<<std::endl;
  }
  l.closeCatalog();    
  
}

