#include <iostream>
#include <exception>
#include "TestDriver.h"
#include "SealKernel/Exception.h"

int main( int, char** ) {
  try {
    TestDriver driver;

    std::cout << "[OVAL] Writing data" << std::endl;
    driver.writeData();
    std::cout << "[OVAL] ...done" << std::endl;

    std::cout << "[OVAL] Reading back the data" << std::endl;
    driver.readData();
    std::cout << "[OVAL] ...done" << std::endl;

    std::cout << "[OVAL] Appending and reading back the data" << std::endl;
    driver.appendReadData();
    std::cout << "[OVAL] ...done" << std::endl;
  }
  catch ( seal::Exception& error ) {
    std::cerr << error.what() << std::endl;
    return 1;
  }
  catch ( std::exception& e ) {
    std::cerr << e.what() << std::endl;
    return 1;
  }
  std::cout << "[OVAL] Exiting..." << std::endl;
  return 0;
}
