#ifndef CATALOGPOPULATOR_H
#define CATALOGPOPULATOR_H
#include <vector>
#include <fstream>
#include "FileCatalog/IFileCatalog.h"
#include "FileCatalog/FCEntry.h"
class CatalogPopulator{
 public:
  CatalogPopulator();
  ~CatalogPopulator();
  void openCatalog(const std::string& contactstr);
  void closeCatalog();
  void populateCatalogFromfile(const std::string& iname);
  void defineSchema();
private:
  void parselfn(const std::string& lfn, pool::MetaDataEntry& attrs);
  bool isMETA(const std::string& lfn) const;
  bool isEVD(const std::string& lfn) const;
  void parseseparator( const std::string& lfn, const std::string& separators, std::vector<std::string>& words );
  void parsemeta(const std::string& lfn, pool::MetaDataEntry& attrs);
  void parseevd(const std::string& lfn, pool::MetaDataEntry& attrs);
  void parseother(const std::string& lfn, pool::MetaDataEntry& attrs);
 private:
  std::vector<std::string> m_lfns;
  pool::IFileCatalog* m_catalog;
  pool::MetaDataEntry* m_cmspec;
};

#endif
