#include "TestBase/TestBase.h"
#include "StorageSvc/DbType.h"
#include "StorageSvc/poolDb.h"

class TestClass;

namespace pool  {

  class Token;

  class ObjectStorageTest : public TestBase {
    protected:
    const std::string m_dbName1;
    const std::string m_dbName2;
    const DbType m_type1;
    const DbType m_type2;

    virtual bool compareExpected(std::string label,unsigned int i,const TestClass& obj);

    std::vector<std::string> m_tokens;

    public: 
    ObjectStorageTest(std::string& dbName1, const DbType& storage_type1,
               std::string& dbName2, const DbType& storage_type2);

    virtual ~ObjectStorageTest();

    /// write objects to the persistent store
    void write(unsigned int NC);

     /// write objects to the persistent store
    void update(unsigned int NC,std::string expectedLabel="WRITE");

    /// write objects to the persistent store
    void erase(unsigned int NC,std::string expectedLabel="WRITE");

    /// read objects from the persistent store
    void read(unsigned int n_expected,std::string label="");

    virtual void execute(){}

    std::vector<std::string>& tokens();

  };

}

