#ifndef STRESSTESTTIMER_H
#define STRESSTESTTIMER_H

#include <sys/time.h>

typedef long long UTime;

 /** @class Timer StressTestTimer.h Tests/Libraries/StressTestBase/StressTestTimer.h

    Timer provides simple microsecond-precision timing functions.

    @author Tim Barrass
    @date 8/5/2003
*/
class Timer {
public:
  Timer() {};
  virtual ~Timer() {};
  void start() { m_start = theTime(); }
  UTime elapsedAsMicroseconds() { return (theTime() - m_start); }
  float elapsedAsSeconds() { return ((theTime() - m_start) / 1000000.0f); }
protected:
  UTime theTime() {
    timeval myTime;
    gettimeofday(&myTime,NULL);
    return 1000000ll*myTime.tv_sec + myTime.tv_usec;
  }
private:
  UTime m_start;
};

#endif // STRESSTESTTIMER_H


