#ifndef POOL_TESTBLOBSTREAMINGSERVICE_H
#define POOL_TESTBLOBSTREAMINGSERVICE_H

#include "RelationalStorageService/IBlobStreamingService.h"
#include "SealKernel/Service.h"

namespace pool {

  /// Test implementation of the IBlobStreamingService interface
  
  class TestBlobStreamingService : public seal::Service,
                                   virtual public IBlobStreamingService
  {
    DECLARE_SEAL_COMPONENT;

  public:
    /// Standard Constructor
    TestBlobStreamingService( seal::Context* c );
    
    /// Standard Constructor with a component key
    TestBlobStreamingService( seal::Context* c, const std::string& key );

    /// Standard Destructor
    virtual ~TestBlobStreamingService();

  public:
    /// Returns a new NON-PORTABLE streamer for writing into a BLOB
    IBlobWriter* newWriter( const ROOT::Reflex::Type& classDictionary,
                            const std::string& version ) const;

    /// Returns a new NON-PORTABLE streamer for reading from a BLOB
    IBlobReader* newReader( const ROOT::Reflex::Type& classDictionary,
                            const std::string& version ) const;
  };

}

#endif
