#ifndef DATALINK_H
#define DATALINK_H

#include "IDataLink.h"
#include "DataRef.h"

class TargetObject;
class IDataCache;

class DataLink : virtual public IDataLink
{
public:
  DataLink();
  DataLink( const DataLink& rhs );
  DataLink& operator=( const DataLink& rhs );
  DataLink( IDataCache* cache, TargetObject* object );
  DataLink( IDataCache* cache, const std::string& key );
  virtual ~DataLink(){}

  void setLink( IDataCache* cache, TargetObject* object );
  void setLink( IDataCache* cache, const std::string& key );

  TargetObject* operator->();
  const TargetObject* operator->() const;

  TargetObject*  objectPtr();
  const TargetObject*  objectPtr() const;

  const std::string& key() const;
  int cacheLocationIndex() const;

private:
  mutable std::string   m_key;
  mutable DataRef       m_dataRef;
};

#include "DataLink.inl"

#endif
