#include "IDataCache.h"
#include "TargetObject.h"

inline
DataLink::DataLink():
  m_cache( 0 ),
  m_object( 0 ),
  m_key( "" )
{}

inline
DataLink::DataLink( IDataCache* cache, TargetObject* object ):
  m_cache( 0 ),
  m_object( 0 ),
  m_key( "" )
{
  this->setLink( cache, object );
}

inline
DataLink::DataLink( IDataCache* cache, const std::string& key ):
  m_cache( cache ),
  m_object( 0 ),
  m_key( key )
{}

inline void
DataLink::setLink( IDataCache* cache, TargetObject* object )
{
  m_cache = cache;
  m_key = m_cache->key( object );
}

inline void
DataLink::setLink( IDataCache* cache, const std::string& key )
{
  m_cache = cache;
  m_key = key;
}

inline TargetObject*
DataLink::operator->()
{
  return this->objectPtr();
}

inline const TargetObject*
DataLink::operator->() const
{
  return this->objectPtr();
}


inline TargetObject*
DataLink::objectPtr()
{
  if ( ! m_object ) {
    if ( m_cache ) {
      m_object = m_cache->lookup( m_key );
    }
  }
  return m_object;
}


inline const TargetObject*
DataLink::objectPtr() const
{
  if ( ! m_object ) {
    if ( m_cache ) {
      m_object = m_cache->lookup( m_key );
    }
  }
  return m_object;
}


inline const std::string&
DataLink::key() const
{
  return m_key;
}
