#ifndef MYDATACALLBACK_H
#define MYDATACALLBACK_H

#include "Reflex/Type.h"
#include "StorageSvc/DataCallBack.h"

class MyDataCallBack : public pool::DataCallBack
{
public:
  MyDataCallBack();

  ~MyDataCallBack();

  pool::DataCallBack* clone() const;

  ROOT::Reflex::Type transientType() const;

  void release();

  void setObject( const void* ptr );

  const void* object() const;

  void setShape( const pool::Shape* shape );

  const pool::Shape* shape() const;

  void setHandler( pool::DataHandler* pSvc );

  pool::DataHandler* handler() const;

  pool::DbStatus start( pool::DataCallBack::CallType action_type,
			void* data,
			void** context);

  pool::DbStatus bind( pool::DataCallBack::CallType action_type,
		       const pool::DbColumn* col_identifier,
		       int col_number,
		       void* context,
		       void** data );

  pool::DbStatus end( pool::DataCallBack::CallType action,
		      void* context );

  pool::DbStatus notify( pool::DataCallBack::CallType action_type,
			 int data_type,
			 ROOT::Reflex::Type reflection,
			 void* object_ptr,
			 void* data );
private:
  ROOT::Reflex::Type              m_transientType;
  pool::DataHandler*                m_dataHandler;
  const pool::Shape*                m_shape;
  const void*                       m_transientObjectData;
  void*                             m_persistentObjectData;
};

#endif
