#ifndef TESTDRIVER_H
#define TESTDRIVER_H

#include <vector>
#include <string>
#include "TestDictionary/SimpleTestClass.h"
#include "TestDictionary/TestClassPrimitives.h"
#include "TestDictionary/TestClassVectors.h"
#include "TestDictionary/TestClassSimpleContainers.h"

namespace pool {
  class Token;
  class IFileCatalog;
}

namespace pool {

  class TestDriver {
  public:
    TestDriver();
    ~TestDriver();
    void loadLibraries( const std::vector<std::string>& libraries );
    void testPlugins();
    void write();
    void read();
    void readCollections();
    void updateObjects();
    void readBackUpdatedObjects();
    void clearCache();
    void readFileSizes();

  private:
    pool::IFileCatalog*   m_fileCatalog;
    std::string           m_fileName1;
    std::string           m_fileName2;
    int                   m_events;
    int                   m_eventsToCommitAndHold;
    std::vector< pool::Token* > m_tokens;
    std::vector< SimpleTestClass > m_simpleTestClass;
    std::vector< TestClassPrimitives > m_testClassPrimitives;
    std::vector< TestClassVectors > m_testClassVectors;
    std::vector< TestClassSimpleContainers > m_testClassSimpleContainers;
  };

}

#endif
