#ifndef INCLUDE_TEST_TRANSACTION_OBSERVER_H
#define INCLUDE_TEST_TRANSACTION_OBSERVER_H

#include <iosfwd>
#include <string>
#include "PersistencySvc/ITransactionObserver.h"

class TestTransactionObserver : virtual public pool::ITransactionObserver
{
public:
  /// Constructor
  explicit TestTransactionObserver( const std::string& name,
				    std::ostream& os );

  /// Destructor
  virtual ~TestTransactionObserver();

  /// Responds to a start of a read transaction
  bool respondToStartRead();
  
  /// Responds to a start of an update transaction
  bool respondToStartUpdate();
  
  /// Responds to a committing of a transaction
  bool respondToCommit();
  
  /// Responds to an aborting of a transaction
  bool respondToRollBack();
  
  /// Responds to the reverting of a transaction into update mode
  bool respondToUpdate();

private:
  std::string   m_name;
  std::ostream& m_os;
};

#endif
