#!/usr/bin/env python2.2

import os
import sys
import shutil
import commands
import fileinput
import string

def printUsage( executable ):
    print "Usage: " + executable
    print "              [--source sourcefolder ]   : The src folder of the project."
    print "              [--out qmtestfolder    ]   : The folder for the generated qmtest files."
    
def parseArguments( args ):
    sourcefolder = None
    qmtestfolder = None
    if '--help' in args:
        printUsage( os.path.split( args[0] )[1] )
        return (None,None)
    if '--source' in args:
        sourcefolder = args[ args.index( '--source' ) + 1 ]
        if not os.path.exists( sourcefolder ):
            sys.stderr.write( sourcefolder + ' does not exist or is not a directory.\n' )
            return (None,None)
    if '--out' in args:
        qmtestfolder = args[ args.index( '--out' ) + 1 ]
        if not os.path.exists( qmtestfolder ):
            sys.stderr.write( qmtestfolder + ' does not exist or is not a directory.\n' )
            return (None,None)
    if( sourcefolder==None ):
        print 'Parameter "source" is missing.'
    if(qmtestfolder==None):
        print 'Parameter "out" is missing.'
    return ( sourcefolder, qmtestfolder )
    

# executable
( srcDir, qmtestfolder ) = parseArguments( sys.argv )
if( srcDir==None ) or (qmtestfolder==None):
    sys.exit(-1)
filesInDirectory = os.listdir( srcDir )
for file in filesInDirectory:
    if (file!='Tests') and (file!='CVS'):
        filepath = os.path.join(srcDir,file)
        if os.path.isdir(filepath):
            print 'Examing folder: '+filepath
            innerfiles = os.listdir( filepath )
            testfolder = os.path.join(filepath,'tests')
            if os.path.exists(testfolder):
                print 'Examing test folder: '+testfolder
                testfiles = os.listdir( testfolder )
                for testfile in testfiles:
                    testfilepath = os.path.join(testfolder,testfile)
                    if os.path.isdir( testfilepath ):
                        unittestfiles = os.listdir( testfilepath )
                        if (len(unittestfiles)) and (testfile!='CVS'):
                            print 'Non-empty Unit test folder found: '+testfilepath
                            qmtestfile = string.lower(file)+'_'+string.lower(testfile)+'.qmt'
                            fout=open(os.path.join(qmtestfolder,qmtestfile), 'w')
                            fout.write('<?xml version="1.0" ?><!DOCTYPE extension  PUBLIC "'"-//QM/2.3/Extension//EN"''"http://www.codesourcery.com/qm/dtds/2.3/-//qm/2.3/extension//en.dtd"'"><extension class="LCG_QMTestExtensions.ShellCommandTest" kind="test"><argument name="excluded_lines"><text/></argument><argument name="target_group"><text>.*</text></argument><argument name="stderr"><text>*</text></argument><argument name="stdout"><text/></argument><argument name="prerequisites"><set/></argument><argument name="stdout_ref"><text>unitTest_'+file+'_'+testfile+'.ref</text></argument><argument name="stdout_tol"><integer>0</integer></argument><argument name="exit_code"><integer>0</integer></argument><argument name="stdout_tag"><text>[OVAL]</text></argument><argument name="environment"><set/></argument><argument name="stdout_ref_path"><text>../../src/'+file+'/tests/'+testfile+'/</text></argument><argument name="timeout"><integer>-1</integer></argument><argument name="description_test"><text/></argument><argument name="command"><text>unitTest_'+file+'_'+testfile+'</text></argument><argument name="resources"><set/></argument><argument name="stdin"><text/></argument></extension>')
                            fout.close()
    else:
        print 'Examing Tests folder.'
        filepath = os.path.join(srcDir,file)
        if os.path.isdir(filepath):
            print 'Examing folder: '+filepath
            testfiles = os.listdir( filepath )
            for testfile in testfiles:
                testfilepath = os.path.join(filepath,testfile)
                if (os.path.isdir( testfilepath )) and (testfile!='Libraries') and (testfile!='CVS'):
                    inttestfiles = os.listdir( testfilepath )
                    if (len(inttestfiles)) and (testfile!='CVS'):
                        print 'Non-empty Integration test folder found: '+testfilepath
                        qmtestfile = string.lower(file)+'_'+string.lower(testfile)+'.qmt'
                        fout=open(os.path.join(qmtestfolder,qmtestfile), 'w')
                        fout.write('<?xml version="1.0" ?><!DOCTYPE extension  PUBLIC "'"-//QM/2.3/Extension//EN"'"  "'"http://www.codesourcery.com/qm/dtds/2.3/-//qm/2.3/extension//en.dtd"'"><extension class="LCG_QMTestExtensions.ShellCommandTest" kind="test"><argument name="excluded_lines"><text/></argument><argument name="target_group"><text>.*</text></argument><argument name="stderr"><text>*</text></argument><argument name="stdout"><text/></argument><argument name="prerequisites"><set/></argument><argument name="stdout_ref"><text>test_'+testfile+'.ref</text></argument><argument name="stdout_tol"><integer>0</integer></argument><argument name="exit_code"><integer>0</integer></argument><argument name="stdout_tag"><text>[OVAL]</text></argument><argument name="environment"><set/></argument><argument name="stdout_ref_path"><text>../../src/Tests/'+testfile+'/</text></argument><argument name="timeout"><integer>-1</integer></argument><argument name="description_test"><text/></argument><argument name="command"><text>test_'+testfile+'</text></argument><argument name="resources"><set/></argument><argument name="stdin"><text/></argument></extension>')
                        fout.close()
print 'Ok, qmtest files generated.'
