/* 
 * Concrete implementation of the POOL to LFC MetaData Catalog interface
 * Author : David Smith
 */
#include "LFCCatalog/LFCMetaCatalog.h"
#include "LFCCatalog/LFCCatalog.h"

#include "FileCatalog/FCException.h"

#include "POOLCore/POOLContext.h"
#include "POOLCore/PoolMessageStream.h"

namespace pool {
  LFCMetaCatalog::LFCMetaCatalog(FCImpl* fc) : FCMetaImpl(fc)
  {
  }

  LFCMetaCatalog::~LFCMetaCatalog()
  {
  }
  
  void LFCMetaCatalog::insertMetaData(MetaDataEntry __attribute__((unused)) &mentry) const {
    //PoolMessageStream fclog( "LFCMetaCatalog::insertMetaData", seal::Msg::Nil);
    //fclog<<seal::Msg::Warning<<"no metadata catalog available"<<seal::endmsg;
  }

  void LFCMetaCatalog::createMetaDataSpec( MetaDataEntry __attribute__((unused)) &schemadef) const {
    //PoolMessageStream fclog( "LFCMetaCatalog::createMetaDataSpec", seal::Msg::Nil);
    //fclog<<seal::Msg::Warning<<"no metadata catalog available"<<seal::endmsg;
  }

  void LFCMetaCatalog::updateMetaDataSpec( MetaDataEntry __attribute__((unused)) &schemadef, const FileCatalog::MetaUpdateMode __attribute__((unused)) metamode) const {
    //PoolMessageStream fclog( "LFCMetaCatalog::updateMetaDataSpec", seal::Msg::Nil);
    //fclog<<seal::Msg::Warning<<"no metadata catalog available"<<seal::endmsg;
  }

  void LFCMetaCatalog::getMetaDataSpec( MetaDataEntry __attribute__((unused)) &schemadef) const {
    //PoolMessageStream fclog( "LFCMetaCatalog::getMetaDataSpec", seal::Msg::Nil);
    //fclog<<seal::Msg::Warning<<"no metadata catalog available"<<seal::endmsg;
  }

  void LFCMetaCatalog::dropMetaDataSpec() const {
    //PoolMessageStream fclog( "LFCMetaCatalog::dropMetaDataSpec", seal::Msg::Nil);
    //fclog<<seal::Msg::Warning<<"no metadata catalog available"<<seal::endmsg;
  }

  void LFCMetaCatalog::deleteMetaData(const FileCatalog::FileID __attribute__((unused)) &guid) const {
    //PoolMessageStream fclog( "LFCMetaCatalog::deleteMetaData", seal::Msg::Nil);
    //fclog<<seal::Msg::Warning<<"no metadata catalog available"<<seal::endmsg;
  }
  
  //functions for bulk query
    
  bool LFCMetaCatalog::retrievePFN(const std::string& query, FCBuf<PFNEntry>& buf, const size_t& start ) {
    return m_fc->retrievePFN(query, buf, start);
  }

  bool LFCMetaCatalog::retrieveLFN(const std::string& query, FCBuf<LFNEntry>& buf, const size_t& start ) {
    return m_fc->retrieveLFN(query, buf, start);
  }

  bool LFCMetaCatalog::retrieveGuid(const std::string& query, FCBuf<FileCatalog::FileID>& buf, const size_t& start ) {
    return m_fc->retrieveGuid(query, buf, start);
  }

  bool LFCMetaCatalog::retrieveMetaData(const std::string __attribute__((unused)) &query, FCBuf<MetaDataEntry> __attribute__((unused)) &buf, const size_t __attribute__((unused)) &start ) {
    //PoolMessageStream fclog( "LFCMetaCatalog::retrieveMetaData", seal::Msg::Nil);
    //fclog<<seal::Msg::Warning<<"no metadata catalog available"<<seal::endmsg;

    return false;
  }
}
