#ifndef OBJECTRELATIONALACCESS_OBJECTRELATIONALELEMENTTYPENAMES_H
#define OBJECTRELATIONALACCESS_OBJECTRELATIONALELEMENTTYPENAMES_H

#include <string>

namespace pool {
  class ObjectRelationalElementTypeNames {
  public:
    /// Dummy constructor
    ObjectRelationalElementTypeNames(){}

    /// Returns the name of the object mapping element type
    static std::string objectMappingElementType();
    /// Returns the name of the primitive mapping element type
    static std::string primitiveMappingElementType();
    /// Returns the name of the array mapping element type
    static std::string arrayMappingElementType();
    /// Returns the name of the array mapping element type
    static std::string CArrayMappingElementType();
    /// Returns the name of the inline array mapping element type
    static std::string inlineCArrayMappingElementType();
    /// Returns the name of the POOL reference mapping element type
    static std::string poolReferenceMappingElementType();
    /// Returns the name of the pointer mapping element type
    static std::string pointerMappingElementType();
    /// Returns the name of the reference mapping element type
    static std::string referenceMappingElementType();
    /// Returns the name of the blon element type
    static std::string blobMappingElementType();
    /// Checks if the provided element type is valid
    static bool isValidMappingElementType( const std::string& elementType );
  };
}

#endif
