inline 
pool::ObjectRelationalMappingElement::ObjectRelationalMappingElement():
  m_elementType(pool::ObjectRelationalMappingElement::Undefined),
  m_scopeName(""),
  m_variableName(""),
  m_variableType(""),
  m_tableName(""),
  m_columnNames(),
  m_subElements(),
  m_scopeForColumnName("") {
}

inline 
pool::ObjectRelationalMappingElement::ObjectRelationalMappingElement( const ObjectRelationalMappingElement& element):
  m_elementType(element.m_elementType),
  m_scopeName(element.m_scopeName),
  m_variableName(element.m_variableName),
  m_variableType(element.m_variableType),
  m_tableName(element.m_tableName),
  m_columnNames(element.m_columnNames),
  m_subElements(element.m_subElements),
  m_scopeForColumnName(element.m_scopeForColumnName) {
}

inline pool::ObjectRelationalMappingElement& 
pool::ObjectRelationalMappingElement::operator=(const ObjectRelationalMappingElement& element){
  m_elementType = element.m_elementType;
  m_scopeName = element.m_scopeName;
  m_variableName = element.m_variableName;
  m_variableType = element.m_variableType;
  m_tableName = element.m_tableName;
  m_columnNames = element.m_columnNames;
  m_subElements = element.m_subElements;
  m_scopeForColumnName = element.m_scopeForColumnName;
  return *this;
}


inline pool::ObjectRelationalMappingElement::iterator
pool::ObjectRelationalMappingElement::begin()
{
  return m_subElements.begin();
}

inline pool::ObjectRelationalMappingElement::const_iterator
pool::ObjectRelationalMappingElement::begin() const
{
  return m_subElements.begin();
}

inline pool::ObjectRelationalMappingElement::iterator
pool::ObjectRelationalMappingElement::end()
{
  return m_subElements.end();
}

inline pool::ObjectRelationalMappingElement::const_iterator
pool::ObjectRelationalMappingElement::end() const
{
  return m_subElements.end();
}

inline pool::ObjectRelationalMappingElement::iterator
pool::ObjectRelationalMappingElement::find( const std::string& key )
{
  return m_subElements.find( key );
}

inline pool::ObjectRelationalMappingElement::const_iterator
pool::ObjectRelationalMappingElement::find( const std::string& key ) const
{
  return m_subElements.find( key );
}

inline bool
pool::ObjectRelationalMappingElement::removeSubElement( const std::string& key ) 
{
  return m_subElements.erase( key )>0;
}

inline pool::ObjectRelationalMappingElement::ElementType
pool::ObjectRelationalMappingElement::elementType() const
{
  return m_elementType;
}

inline const std::string&
pool::ObjectRelationalMappingElement::scopeName() const
{
  return m_scopeName;
}

inline const std::string&
pool::ObjectRelationalMappingElement::variableName() const
{
  return m_variableName;
}

inline const std::string&
pool::ObjectRelationalMappingElement::variableType() const
{
  return m_variableType;
}

inline const std::string&
pool::ObjectRelationalMappingElement::tableName() const
{
  return m_tableName;
}

inline const std::vector< std::string >&
pool::ObjectRelationalMappingElement::columnNames() const
{
  return m_columnNames;
}
   
inline const std::string& 
pool::ObjectRelationalMappingElement::scopeForColumnName() const {
  return m_scopeForColumnName;
}
