#include "ObjectRelationalAccess/ObjectRelationalMapping.h"
#include "ObjectRelationalAccess/ObjectRelationalNames.h"

pool::ObjectRelationalMapping::ObjectRelationalMapping( const std::string& version ):
  m_version( version ),
  m_elements()
{}

std::set<std::string>
pool::ObjectRelationalMapping::involvedTables(){
  std::set<std::string> involvedTables;
  const_iterator iel = begin();
  for(const_iterator iel=begin();
      iel!=end();++iel){
    std::set<std::string> elementTables = iel->second.involvedTables();
    for(std::set<std::string>::const_iterator iT=elementTables.begin();
        iT!=elementTables.end();++iT){
      involvedTables.insert(*iT);
    }
  }
  return involvedTables;
}

pool::ObjectRelationalMappingElement&
pool::ObjectRelationalMapping::appendElement( const std::string& className,
                                              const std::string& tableName )
{
  return m_elements.insert( std::make_pair( className,
                                            pool::ObjectRelationalMappingElement( pool::ObjectRelationalAccess::ObjectRelationalNames::objectMappingElementType(),
                                                                                  className,
                                                                                  className,
                                                                                  tableName ) ) ).first->second;
}

void pool::ObjectRelationalMapping::override(const ObjectRelationalMapping& source)
{
  for(iterator iel=begin();
      iel!=end();++iel){
    const_iterator iTarg = source.find(iel->first);
    if(iTarg!=source.end()){
      iel->second.override(iTarg->second);
    }
  }  
}

