#include "ObjectRelationalAccess/ObjectRelationalException.h"
#include <string>
#include <fstream>
#include "../../src/XMLDatabaseManagerDriver.h"
#include "ObjectRelationalAccess/ObjectRelationalMappingDescriptor.h"
#include "../../src/StringTokenize.h"
#include <sstream>
#include <iostream>

int main( int argc, char** argv  )
{
  if(argc>0){
    try{
      pool::XMLDatabaseManagerDriver reader;
      std::string file;
      if(argc>1) { 
        file = argv[1];
      } else {
        file = "input.xml";
      }
      std::cout << "[OVAL] Parsing file " << file << std::endl;
      pool::ObjectRelationalDatabaseDescriptor* dbstruct = reader.read(file);

      std::string outFile("tmp.xml");
      std::ofstream outFileStream;
      outFileStream.open (outFile.c_str(), std::fstream::out);
      std::cout << "[OVAL] Re-Writing mapping on tmp file " << outFile << std::endl;
      reader.write(*dbstruct,outFileStream);
      outFileStream.close();
    
      std::stringstream sout1;  
      std::stringstream sout2;  
      reader.write(*dbstruct,sout1);
      delete dbstruct;      
      dbstruct = reader.read(outFile);
      reader.write(*dbstruct,sout2);
      delete dbstruct;
      if(sout1.str()!=sout2.str()){
        std::cout << "[OVAL] ERROR: different mapping rebuilt." <<std::endl;
        return 0;
      } else {
        std::cout << "[OVAL] Original mapping and rebuilt one are equals." <<std::endl;
      }

      std::cout <<std::endl;
      std::vector<std::string> lines;
      std::stringstream sendl;
      sendl << std::endl;
      pool::stringTokenize(sout1.str(),lines,sendl.str());
      for(unsigned int i=0;i<lines.size();i++){
        std::cout << "[OVAL] " << lines[i] <<std::endl;
      }
    } catch (const pool::ObjectRelationalException& ex){
      std::cout << "[OVAL] test ERROR: " << ex.what() << std::endl;
    }
    return 0;
  }
  return 1;
}
