#include <iostream>
#include <vector>
#include <exception>
#include "ObjectRelationalAccess/ObjectRelationalTableNameRationalizer.h"
#include "DummySchema.h"

int main(int, char**)
{
  try {
    DummySchema schema;
    pool::ObjectRelationalTableNameRationalizer rationalizer( schema, 15 );

    std::vector< std::string > suggestedNames;
    suggestedNames.push_back( "T_CLASS_A" );
    suggestedNames.push_back( "T_CLASS_B" );
    suggestedNames.push_back( "T_CLASS_C" );
    suggestedNames.push_back( "T_A_VERY_LONG_CLASS_NAME_1" );
    suggestedNames.push_back( "T_A_VERY_LONG_CLASS_NAME_2" );
    suggestedNames.push_back( "T_CLASS_A" );
    suggestedNames.push_back( "T_CLASS_B" );
    suggestedNames.push_back( "T_CLASS_C" );
    suggestedNames.push_back( "T_A_VERY_LONG_CLASS_NAME_1" );
    suggestedNames.push_back( "T_A_VERY_LONG_CLASS_NAME_2" );

    std::cout << "Existing tables in the schema : " << std::endl;
    std::set< std::string > tablesInSchema = schema.listTables();
    for ( std::set< std::string >::const_iterator iTable = tablesInSchema.begin();
          iTable != tablesInSchema.end(); ++iTable ) {
      std::cout << "    " << *iTable << std::endl;
    }

    for ( std::vector< std::string >::const_iterator iName = suggestedNames.begin();
          iName != suggestedNames.end(); ++iName ) {
      std::cout << "Suggested name is \"" << *iName << "\". Valid name is \"" << rationalizer.validNameForNewTable( *iName ) << "\"." << std::endl;
    }
    std::cout << "Exiting..." << std::endl;

  }
  catch ( std::exception& e )  {
    std::cerr << e.what() << std::endl;
    return 1;
  }
  catch ( ... ) {
    std::cerr << "Funny error" << std::endl;
    return 1;
  }
  return 0;
}
