#include "RelationalMetaDataCatalogImplementation.h"
#include "RelationalFileCatalogImplementation.h"

namespace pool
{
  namespace RelationalFileCatalog
  {
    
    RelationalMetaDataCatalogImplementation::RelationalMetaDataCatalogImplementation( pool::FCImpl* fc )
      : pool::FCMetaImpl( fc ), m_rfc( 0 )
    {
      m_rfc = dynamic_cast<RelationalFileCatalogImplementation*>(fc);
    }
    
    RelationalMetaDataCatalogImplementation::~RelationalMetaDataCatalogImplementation()
    {
    }
      
    void RelationalMetaDataCatalogImplementation::insertMetaData(MetaDataEntry& mentry) const
    {
      m_rfc->insertMetaData( mentry );
    }
      
    void RelationalMetaDataCatalogImplementation::createMetaDataSpec(MetaDataEntry& schemadef) const
    {
      m_rfc->createMetaDataSpec( schemadef );
    }

    void RelationalMetaDataCatalogImplementation::updateMetaDataSpec(MetaDataEntry& newschemadef,
                                                                     const FileCatalog::MetaUpdateMode metamode) const
    {
      m_rfc->updateMetaDataSpec( newschemadef, metamode );
    }

    void RelationalMetaDataCatalogImplementation::getMetaDataSpec(MetaDataEntry& spec) const
    {
      m_rfc->getMetaDataSpec( spec );
    }

    void RelationalMetaDataCatalogImplementation::dropMetaDataSpec() const
    {
      m_rfc->dropMetaDataSpec();
    }

    void RelationalMetaDataCatalogImplementation::deleteMetaData(const FileCatalog::FileID& guid) const
    {
      m_rfc->deleteMetaData( guid );
    }

    bool RelationalMetaDataCatalogImplementation::retrievePFN(const std::string& query,
                                                              FCBuf<PFNEntry>& buf,
                                                              const size_t& start )
    {
      return( m_rfc->retrievePFN( query, buf, start ) );
    }

    bool RelationalMetaDataCatalogImplementation::retrieveLFN(const std::string& query,
                                                              FCBuf<LFNEntry>& buf,
                                                              const size_t& start )
    {
      return( m_rfc->retrieveLFN( query, buf, start ) );
    }

    bool RelationalMetaDataCatalogImplementation::retrieveMetaData(const std::string& query,
                                                                   FCBuf<MetaDataEntry>& buf,
                                                                   const size_t& start )
    {
      return( m_rfc->retrieveMetaData( query, buf, start ) );
    }
    
    bool RelationalMetaDataCatalogImplementation::retrieveGuid(const std::string& query,
                                                               FCBuf<FileCatalog::FileID>& buf,
                                                               const size_t& start )
    {
      return( m_rfc->retrieveGuid( query, buf, start ) );
    }
  }
}
