#ifndef RELATIONALFILECATALOG_QUERYPARSER_H
#define RELATIONALFILECATALOG_QUERYPARSER_H

#include <string>
#include <map>
#include <vector>

namespace pool {

  namespace RelationalFileCatalog {

    /**
     * @class UserQueryParser UserQueryParser.h
     *
     * Utility class for parsing the user submitted queries.
     *
     */

    class UserQueryParser {
    public:

      typedef std::pair< std::string, std::vector< std::string > > ParserResult;

      /// Parses a user query
      static ParserResult parse( const std::string& userQuery,
                                 const std::map< std::string, int >& metadataVariables,
                                 const std::string& tableForGuid );
    };

  }

}

#endif
