#ifndef CARRAY_ITERATOR_HANDLER_H
#define CARRAY_ITERATOR_HANDLER_H

#include "Reflex/Type.h"
#include "IContainerIteratorHandler.h"

namespace pool {

  namespace RelationalStorageService {

    class CArrayIteratorHandler : virtual public IContainerIteratorHandler {
    public:
      /// Constructor
      CArrayIteratorHandler( const void* startAddress,
                             const ROOT::Reflex::Type& iteratorReturnType );

      /// Destructor
      ~CArrayIteratorHandler();

      /// Increments itself
      void increment();

      /// Returns the current object
      void* object();

      /// Returns the return type of the iterator dereference method
      ROOT::Reflex::Type returnType() const;

    private:

      /// The return type of the iterator dereference method
      ROOT::Reflex::Type m_returnType;
      
      /// Current element object pointer
      const void* m_currentElement;
    };

  }

}

#endif
