#ifndef ICONTAINER_HANDLER_H
#define ICONTAINER_HANDLER_H

#include "Reflex/Type.h"
#include <cstddef>

namespace pool {

  namespace RelationalStorageService {

    class IContainerIteratorHandler;

    class IContainerHandler {

    public:
      /// Destructor
      virtual ~IContainerHandler() {}

      /// Returns the size of the container
      virtual size_t size( const void* address ) = 0;

      /// Returns an initialized iterator
      virtual IContainerIteratorHandler* iterate( const void* address ) = 0;

      /// Appends a new element and returns its address
      virtual void appendNewElement( void* address, void* data ) = 0;

      /// Clear the content of the container
      virtual void clear( const void* address ) = 0;

      /// Returns the associativeness of the container
      virtual bool isAssociative() const { return false; }

      /// Returns the iterator return type
      virtual ROOT::Reflex::Type iteratorReturnType() const = 0;
    };

  }

}

#endif
