#include "PoolContainerManagerFactory.h"
#include "PoolPrimitivesContainerManager.h"
#include "PoolHomogeneousContainerManager.h"
#include "PoolPolymorphicContainerManager.h"

pool::RelationalStorageService::PoolBaseContainerManager*
pool::RelationalStorageService::PoolContainerManagerFactory::newPrimitivesContainer( int containerId,
                                                                                     coral::ISchema& schema,
                                                                                     const std::string& containerTableName,
                                                                                     seal::Context* context,
                                                                                     const std::string& serviceName )
{
  return new pool::RelationalStorageService::PoolPrimitivesContainerManager( containerId,
                                                                             schema, 
                                                                             containerTableName, 
                                                                             context, 
                                                                             serviceName );
}



pool::RelationalStorageService::PoolBaseContainerManager*
pool::RelationalStorageService::PoolContainerManagerFactory::newHomogeneousContainer( int containerId,
                                                                                      coral::ISchema& schema,
                                                                                      const pool::RelationalStorageService::MappingInformation& mapping,
                                                                                      seal::Context* context,
                                                                                      const std::string& serviceName )
{
  return new pool::RelationalStorageService::PoolHomogeneousContainerManager( containerId,
                                                                              schema, 
                                                                              mapping, 
                                                                              context, 
                                                                              serviceName );
}



pool::RelationalStorageService::PoolBaseContainerManager*
pool::RelationalStorageService::PoolContainerManagerFactory::newPolymorphicContainer( int containerId,
                                                                                      const std::string& containerName,
                                                                                      coral::ISchema& schema,
                                                                                      const std::string& containerTableName,
                                                                                      pool::RelationalStorageService::MappingManager& mappingManager,
                                                                                      pool::RelationalStorageService::MappingSequence& mappingSequences,                                                                                     
                                                                                      seal::Context* context,
                                                                                      const std::string& serviceName )

{
  return new pool::RelationalStorageService::PoolPolymorphicContainerManager( containerId,
                                                                              containerName,
                                                                              schema,
                                                                              containerTableName,
                                                                              mappingManager,
                                                                              mappingSequences, 
                                                                              context, 
                                                                              serviceName );
}
