#ifndef POOLCONTAINERMANAGERFACTORY_H
#define POOLCONTAINERMANAGERFACTORY_H

#include <string>

namespace seal {
  class Context;
}

namespace coral {

  class ISchema;
}

namespace pool {

  namespace RelationalStorageService {

    class PoolBaseContainerManager;
    class MappingManager;
    class MappingSequence;
    class MappingInformation;

    class PoolContainerManagerFactory {
    public:
      static PoolBaseContainerManager* newPrimitivesContainer( int containerId,
                                                               coral::ISchema& schema,
                                                               const std::string& containerTableName,             
                                                               seal::Context* context,
                                                               const std::string& serviceName );

      static PoolBaseContainerManager* newHomogeneousContainer( int containerId,
                                                                coral::ISchema& schema,
                                                                const pool::RelationalStorageService::MappingInformation& mapping,
                                                               seal::Context* context,
                                                               const std::string& serviceName );

      static PoolBaseContainerManager* newPolymorphicContainer( int containerId,
                                                                const std::string& containerName,
                                                                coral::ISchema& schema,
                                                                const std::string& containerTableName,
                                                                MappingManager& mappingManager,
                                                                MappingSequence& mappingSequences,
                                                                seal::Context* context,
                                                                const std::string& serviceName );
    };
  }
}


#endif
