#ifndef RELATIONALSTORAGESERVICE_RELATIONALDOMAIN_H
#define RELATIONALSTORAGESERVICE_RELATIONALDOMAIN_H

#include "StorageSvc/DbDomainImp.h"

namespace seal {
  class Context;
}

namespace pool {

  namespace RelationalStorageService {

    /**
     * @class RelationalDomain RelationalDomain.h
     * Extension of the default implementation DbDomainImp for the object storage
     * using the POOL Relational backend
     */

    class RelationalDomain : public pool::DbDomainImp
    {
    public:
      /// Standard constructor
      explicit RelationalDomain( pool::IOODatabase* idb,
                                 const std::string& name,
                                 seal::Context* context );

      /// Standard destructor
      virtual ~RelationalDomain();

      // Methods from the base class

      /// Check for Database existence
      /** @param name      [IN]  Name of the database to be checked.
       *
       * @return Boolean value indicating the database existence.
       */
      bool existsDbase( const std::string& name );

    private:
      /// The "service" name
      std::string m_name;

      /// The "service" context
      seal::Context*   m_context;
    };

  }

}

#endif
