#ifndef RELATIONALSTORAGESERVICE_RELATIONALOODBIMPLEMENTATION_H
#define RELATIONALSTORAGESERVICE_RELATIONALOODBIMPLEMENTATION_H

#include "StorageSvc/OODatabaseImp.h"

namespace seal {
  class Context;
}

namespace pool {

  namespace RelationalStorageService {

    class RelationalOODbImplementation  : public OODatabaseImp  {
    public:
      /// Standard constructor required by the plugin instantiation
      explicit RelationalOODbImplementation( void* context );
      /// Standard constructor required by the plugin instantiation
      RelationalOODbImplementation( void* context, const pool::DbType& type );
      /// Destructor
      virtual ~RelationalOODbImplementation();
      /// Label of the specific class
      static const char* catalogLabel();
      /// Create Relational Domain object
      pool::IDbDomain* createDomain();
      /// Create Relational Database object
      pool::IDbDatabase* createDatabase();
      /// Create Relational Container object
      pool::IDbContainer* createContainer( const pool::DbType& type );

    private:
      /// The name of this "service"
      std::string m_serviceName;
      /// The local context of this "service"
      seal::Context* m_context;
    };
  }
}

#endif
