#ifndef RELATIONALPOOLHOMOGENEOUSCONTAINER_H
#define RELATIONALPOOLHOMOGENEOUSCONTAINER_H

#include "RelationalPoolContainer.h"

namespace pool {

  namespace RelationalStorageService {

    /** @class RelationalPoolHomogeneousContainer RelationalPoolHomogeneousContainer.h
     *
     * Extension of the default implementation DbContainerImp for the object storage
     * using the POOL Relational backend handling homogeneous objects
     */

    class RelationalPoolHomogeneousContainer : public RelationalPoolContainer
    {
    public:
      /// Constructor
      RelationalPoolHomogeneousContainer( pool::IOODatabase* idb,
                                          const std::string& name,
                                          seal::Context* context );

      /// Destructor
      ~RelationalPoolHomogeneousContainer();

    protected:
      /// Loads the correct container from the database manager
      PoolBaseContainerManager* createContainerManager( PoolDatabaseManager& databaseManager,
                                                        const std::string& containerName,
                                                        const pool::DbTypeInfo* info );
    };

  }

}

#endif
