#ifndef SPECIALCONTAINER_HANDLER_H
#define SPECIALCONTAINER_HANDLER_H

#include "IContainerHandler.h"

namespace pool {

  namespace RelationalStorageService {

    class SpecialContainerHandler : virtual public IContainerHandler {

    public:
      /// Constructor
      explicit SpecialContainerHandler( const ROOT::Reflex::Type& dictionary );

      /// Destructor
      ~SpecialContainerHandler();

      /// Returns the size of the container
      size_t size( const void* address );

      /// Returns an initialized iterator
      IContainerIteratorHandler* iterate( const void* address );

      /// Appends a new element and returns its address of the object reference
      void appendNewElement( void* address, void* data );

      /// Clear the content of the container
      void clear( const void* address );

      /// Returns the iterator return type
      ROOT::Reflex::Type iteratorReturnType() const;

    private:
      /// The handler of the unserlying container
      IContainerHandler* m_containerHandler;

      /// The offset of the underlying container
      int m_containerOffset;
    };

  }

}

#endif
